package com.idtechproducts.unipayemv.demo;

import java.io.UnsupportedEncodingException;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Vector;

import com.idtechproducts.emv.UniPayEMV;
import com.idtechproducts.emv.UniPay_ApplicationID;
import com.idtechproducts.device.IDT_Device;
import com.idtechproducts.device.ErrorCode;
import com.idtechproducts.unipay.demo.R;
import com.idtechproducts.unipayemv.demo.UniPayEMVDemo;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public	class DlgAID extends Dialog implements android.view.View.OnClickListener,OnItemSelectedListener{
	public DlgAID(UniPayEMVDemo context, IDT_Device myUniPayReader2 , UniPayEMV myUniPayEMV2){
        super(context);
        myUniPayReader = myUniPayReader2;
        myUniPayEMV = myUniPayEMV2;
        myMainUI = context;
	}
    public void DisplayDlg(){
     setContentView(R.layout.dlg_aid);
     InitializeUI();
     setProperty();
     setTitle("UniPay AID Settings");//set the title
     show();//show the dialog 
    }
     //Set property of the dialog
    public void setProperty(){
         window=getWindow();//get the window��
         WindowManager.LayoutParams wl = window.getAttributes();
         wl.x =0;//x pos of the dlg
         wl.y =30;//y pos of the dlg
         wl.alpha=0.9f;//alpha of the dialog window
         wl.gravity=Gravity.TOP;        
         window.setAttributes(wl);
	}

	public void onClick(View arg0) {
		// TODO Auto-generated method stub
 
		switch(arg0.getId()){
		case R.id.dlg_btnBack:
			dismiss(); 
			break;
		case R.id.dlg_btnRemoveAID:
 			removeAID();
 			loadTable();
			break;
		case R.id.dlg_btnSaveAID:
			saveAID();
 			loadTable(); 
		  break;


        default:
        	break;
	 }
	 
	}
	private void InitializeUI()
	{
		tag9F06 = (EditText)findViewById(R.id.tag9F06);
		tag9F01 = (EditText)findViewById(R.id.tag9F01);
		tag9F09 = (EditText)findViewById(R.id.tag9F09);
		tagDF13 = (EditText)findViewById(R.id.tagDF13);
		tagDF14 = (EditText)findViewById(R.id.tagDF14);
		tagDF15 = (EditText)findViewById(R.id.tagDF15);
		tag5F2A = (EditText)findViewById(R.id.tag5F2A);
		tag5F36 = (EditText)findViewById(R.id.tag5F36);
		tagASI = (EditText)findViewById(R.id.tagASI);

	
		
		dlg_btnBack = (Button)findViewById(R.id.dlg_btnBack);
		dlg_btnRemoveAID=(Button)findViewById(R.id.dlg_btnRemoveAID);
		dlg_btnSaveAID=(Button)findViewById(R.id.dlg_btnSaveAID);
		spinner1=(Spinner)findViewById(R.id.spinner1);
		
		loadTable();

		dlg_btnBack.setOnClickListener(this);
		dlg_btnRemoveAID.setOnClickListener(this);
		dlg_btnSaveAID.setOnClickListener(this);
	}
	
	
	
	public void onItemSelected(AdapterView<?> parent, View view, int position,
			long id) {
		Object val = parent.getItemAtPosition(position);
		String item = val.toString();
		loadAID(item);
		
		
	}
	
	
	public void onNothingSelected(AdapterView<?> arg0) {
		
	}
	private void removeAID(){
		myUniPayEMV.removeApplicationData(tag9F06.getText().toString());
		
		
	}
	
	private void saveAID(){
		UniPay_ApplicationID t = new UniPay_ApplicationID();
		 String theAid = tag9F06.getText().toString();
		    t.aidLen[0] = (byte) (theAid.length() /2);
		    int theLen = theAid.length();
		    int target = 32 - theLen;
		    if (theLen < 32) {
		        for (int x = 0; x < target; x++) {
		            theAid = theAid + "0";
		        }
		    }
		    byte b[] = null;
		    b = getBytesFromHexString(theAid);
		    t.aid[0] = b[0];
		    t.aid[1] = b[1];
		    t.aid[2] = b[2];
		    t.aid[3] = b[3];
		    t.aid[4] = b[4];
		    t.aid[5] = b[5];
		    t.aid[6] = b[6];
		    t.aid[7] = b[7];
		    t.aid[8] = b[8];
		    t.aid[9] = b[9];
		    t.aid[10] = b[10];
		    t.aid[11] = b[11];
		    t.aid[12] = b[12];
		    t.aid[13] = b[13];
		    t.aid[14] = b[14];
		    t.aid[15] = b[15];
		
			if (tag9F01.getText().toString().length() != 12){
				displayAlert("Error","Aquirer ID must be 12 hex characters as 6 bytes (example 000000000000)");
				return;
			}
			b = getBytesFromHexString(tag9F01.getText().toString());
			 t.acquirerIdentifier[0] = b[0];
			    t.acquirerIdentifier[1] = b[1];
			    t.acquirerIdentifier[2] = b[2];
			    t.acquirerIdentifier[3] = b[3];
			    t.acquirerIdentifier[4] = b[4];
			    t.acquirerIdentifier[5] = b[5];
			    
				if (tag9F09.getText().toString().length() != 4){
					displayAlert("Error","Application Version Number must be 4 hex characters representing 2 bytes   (example 0089)");
					return;
				}
				b = getBytesFromHexString(tag9F09.getText().toString());
				t.applicationVersionNumber[0] = b[0];
			    t.applicationVersionNumber[1] = b[1];
			    
				if (tagDF14.getText().toString().length() != 10 && tagDF14.getText().toString().length() != 0){
					displayAlert("Error","Default TAC-Denial Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
					return;
				}
				if (tagDF14.getText().toString().length() == 0){
			        t.tacDenial[0] = 0;
			        t.tacDenial[1] = 0;
			        t.tacDenial[2] = 0;
			        t.tacDenial[3] = 0;
			        t.tacDenial[4] = 0;
			        t.useTACDenial[0] = 0;
			    }
			    else{
			    	b = getBytesFromHexString(tagDF14.getText().toString());
			        t.tacDenial[0] = b[0];
			        t.tacDenial[1] = b[1];
			        t.tacDenial[2] = b[2];
			        t.tacDenial[3] = b[3];
			        t.tacDenial[4] = b[4];
			        t.useTACDenial[0] = 0x01;
			    }
				
				if (tagDF15.getText().toString().length() != 10 && tagDF15.getText().toString().length() != 0){
					displayAlert("Error","Default TAC-Online Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
					return;
				}
				if (tagDF15.getText().toString().length() == 0){
			        t.tacOnline[0] = 0;
			        t.tacOnline[1] = 0;
			        t.tacOnline[2] = 0;
			        t.tacOnline[3] = 0;
			        t.tacOnline[4] = 0;
			        t.useTACOnline[0] = 0;
			    }
			    else{
			    	b = getBytesFromHexString(tagDF15.getText().toString());
			        t.tacOnline[0] = b[0];
			        t.tacOnline[1] = b[1];
			        t.tacOnline[2] = b[2];
			        t.tacOnline[3] = b[3];
			        t.tacOnline[4] = b[4];
			        t.useTACOnline[0] = 0x01;
			    }
				
				if (tagDF13.getText().toString().length() != 10 && tagDF13.getText().toString().length() != 0){
					displayAlert("Error","Default TAC-Default Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
					return;
				}
				if (tagDF13.getText().toString().length() == 0){
			        t.tacDefault[0] = 0;
			        t.tacDefault[1] = 0;
			        t.tacDefault[2] = 0;
			        t.tacDefault[3] = 0;
			        t.tacDefault[4] = 0;
			        t.useTACDefault[0] = 0;
			    }
			    else{
			    	b = getBytesFromHexString(tagDF13.getText().toString());
			        t.tacDefault[0] = b[0];
			        t.tacDefault[1] = b[1];
			        t.tacDefault[2] = b[2];
			        t.tacDefault[3] = b[3];
			        t.tacDefault[4] = b[4];
			        t.useTACDefault[0] = 0x01;
			    }
				
				if (tag5F2A.getText().toString().length() != 4){
					displayAlert("Error","Transaction Currency Code must be 4 hex characters representing 2 bytes   (example 008C)");
					return;
				}
				b = getBytesFromHexString(tag5F2A.getText().toString());
				t.transactionCurrencyCode[0] = b[0];
			    t.transactionCurrencyCode[1] = b[1];
			    
			    if (tag5F36.getText().toString().length() != 2){
					displayAlert("Error","Transaction Currency Exponent must be 2 hex characters representing 1 bytes   (example 02)");
					return;
				}
				b = getBytesFromHexString(tag5F36.getText().toString());
				t.transactionCurrencyExponent[0] = b[0];
				
			    if (tagASI.getText().toString().length() != 2){
					displayAlert("Error","Application Selection Indicator must be 2 hex characters representing 1 bytes   (example 00)");
					return;
				}
				b = getBytesFromHexString(tagASI.getText().toString());
				t.applicationSelectionIndicator[0] = b[0];
				
				myUniPayEMV.setApplicationData(t);

		    
	}
	private void loadAID(String name){
		UniPay_ApplicationID t = myUniPayEMV.retrieveApplicationData(name);
		tag9F06.setText(name);
		tag9F01.setText(getHexStringFromBytes(t.acquirerIdentifier));
		tag9F09.setText(getHexStringFromBytes(t.applicationVersionNumber));
		tagDF13.setText(getHexStringFromBytes(t.tacDefault));
		tagDF14.setText(getHexStringFromBytes(t.tacDenial));
		tagDF15.setText(getHexStringFromBytes(t.tacOnline));
		tag5F2A.setText(getHexStringFromBytes(t.transactionCurrencyCode));
		tag5F36.setText(getHexStringFromBytes(t.transactionCurrencyExponent));
		tagASI.setText(getHexStringFromBytes(t.applicationSelectionIndicator));


		
	}
	
	private void loadTable(){
		Vector<String> aids = myUniPayEMV.retrieveAIDList();
		
	    ArrayAdapter<String> adapter;

	    adapter = new ArrayAdapter<String>(myMainUI,
	            android.R.layout.simple_spinner_item, aids);
	    adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	    spinner1.setAdapter(adapter);
	    spinner1.setOnItemSelectedListener(this);
	}

	private Spinner spinner1;
	private Button dlg_btnBack;
	private Button dlg_btnRemoveAID;
	private Button dlg_btnSaveAID;
	private EditText 		tag9F06 ;
	private EditText 		tag9F01 ;
	private EditText 		tag9F09 ;
	private EditText 		tagDF13 ;
	private EditText 		tagDF14 ;
	private EditText 		tagDF15 ;
	private EditText 		tag5F2A ;
	private EditText 		tag5F36 ;
	private EditText 		tagASI ;


	private Window window=null;
	private IDT_Device myUniPayReader = null ; 
	private UniPayEMVDemo myMainUI = null;
	private UniPayEMV myUniPayEMV = null ;
	
	
	private String getHexStringFromBytes(byte []data)
    {
		if(data==null) return null;
		if(data.length<=0) 
			return null;
		StringBuffer hexString = new StringBuffer();
		String fix = null;
		for (int i = 0; i < data.length; i++) {
			fix = Integer.toHexString(0xFF & data[i]);
			if(fix.length()==1)
				fix = "0"+fix;
			hexString.append(fix);
		}
		fix = null;
		fix = hexString.toString();
		return fix;
    }
    public byte[] getBytesFromHexString(String strHexData)
	{
	    if (1==strHexData.length()%2) {
	    	return null;
	    }
	    byte[] bytes = new byte[strHexData.length()/2];
	    try{
		    for (int i=0;i<strHexData.length()/2;i++) {
		    	bytes[i] = (byte) Integer.parseInt(strHexData.substring(i*2, (i+1)*2) , 16);
		    }
	    }
	    catch(Exception ex)
	    {
	    	ex.printStackTrace();
	    	return null;
	    }
	    return bytes;
	}
    
    private String getTextFromBytes(byte []data){
    	String str = "";
		try {
			str = new String(data, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	return str;
    }
    
	private void displayAlert(String title, String message){
		
		AlertDialog.Builder builder = new AlertDialog.Builder(myMainUI);
		builder.setTitle(title);
		builder.setMessage(message);
		builder.setNegativeButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
			}
		});
		AlertDialog alert = builder.create();		
		alert.show();
	}
	
	
}
 
