package com.idtechproducts.unipayemv.demo;

import java.io.UnsupportedEncodingException;

import com.idtechproducts.emv.UniPayEMV;
import com.idtechproducts.emv.UniPayTerminalDataStruct;
import com.idtechproducts.device.ICCSettingStruct;
import com.idtechproducts.device.ResDataStruct;
import com.idtechproducts.device.IDT_Device;
import com.idtechproducts.device.ErrorCode;
import com.idtechproducts.unipay.demo.R;
import com.idtechproducts.unipayemv.demo.UniPayEMVDemo;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;

public	class DlgTerminal extends Dialog implements android.view.View.OnClickListener{
	public DlgTerminal(UniPayEMVDemo context, IDT_Device myUniPayReader2 , UniPayEMV myUniPayEMV2){
        super(context);
        myUniPayReader = myUniPayReader2;
        myUniPayEMV = myUniPayEMV2;
        myMainUI = context;
	}
    public void DisplayDlg(){
     setContentView(R.layout.dlg_terminal);
     InitializeUI();
     setProperty();
     setTitle("UniPay Terminal Settings");//set the title
     show();//show the dialog 
    }
     //Set property of the dialog
    public void setProperty(){
         window=getWindow();//get the window��
         WindowManager.LayoutParams wl = window.getAttributes();
         wl.x =0;//x pos of the dlg
         wl.y =30;//y pos of the dlg
         wl.alpha=0.9f;//alpha of the dialog window
         wl.gravity=Gravity.TOP;        
         window.setAttributes(wl);
	}

	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		switch(arg0.getId()){
		case R.id.dlg_btnBack:
			break;
		case R.id.dlg_btnSaveTerminal:
			saveTerminal();
			return;
	 }
	dismiss();  
	}
	
	
	private void displayAlert(String title, String message){
		
		AlertDialog.Builder builder = new AlertDialog.Builder(myMainUI);
		builder.setTitle(title);
		builder.setMessage(message);
		builder.setNegativeButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
			}
		});
		AlertDialog alert = builder.create();		
		alert.show();
	}
	
	private void saveTerminal(){
		UniPayTerminalDataStruct t = myUniPayEMV.retrieveTerminalData();
		byte b[] = null;
		if (tag9F1A.getText().toString().length() != 4){
			displayAlert("Error","Terminal Country Code must be 4 hex characters representing 2 bytes (example 0840)");
			return;
		}
		b = getBytesFromHexString(tag9F1A.getText().toString());
		t.terminalCountryCode[0] = b[0];
	    t.terminalCountryCode[1] = b[1];
	    
		if (tag9F15.getText().toString().length() != 4){
			displayAlert("Error","Merchant Category Code must be 4 hex characters representing 2 bytes (example 5200)");
			return;
		}
		b = getBytesFromHexString(tag9F15.getText().toString());
		t.merchantCategoryCode[0] = b[0];
	    t.merchantCategoryCode[1] = b[1];
	    
		if (tagDF14.getText().toString().length() != 10 && tagDF14.getText().toString().length() != 0){
			displayAlert("Error","Default TAC-Denial Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
			return;
		}
		if (tagDF14.getText().toString().length() == 0){
	        t.defaultTACDenial[0] = 0;
	        t.defaultTACDenial[1] = 0;
	        t.defaultTACDenial[2] = 0;
	        t.defaultTACDenial[3] = 0;
	        t.defaultTACDenial[4] = 0;
	        t.useDefaultTACDenial[0] = 0;
	    }
	    else{
	    	b = getBytesFromHexString(tagDF14.getText().toString());
	        t.defaultTACDenial[0] = b[0];
	        t.defaultTACDenial[1] = b[1];
	        t.defaultTACDenial[2] = b[2];
	        t.defaultTACDenial[3] = b[3];
	        t.defaultTACDenial[4] = b[4];
	        t.useDefaultTACDenial[0] = 0x01;
	    }
		
		if (tagDF15.getText().toString().length() != 10 && tagDF15.getText().toString().length() != 0){
			displayAlert("Error","Default TAC-Online Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
			return;
		}
		if (tagDF15.getText().toString().length() == 0){
	        t.defaultTACOnline[0] = 0;
	        t.defaultTACOnline[1] = 0;
	        t.defaultTACOnline[2] = 0;
	        t.defaultTACOnline[3] = 0;
	        t.defaultTACOnline[4] = 0;
	        t.useDefaultTACOnline[0] = 0;
	    }
	    else{
	    	b = getBytesFromHexString(tagDF15.getText().toString());
	        t.defaultTACOnline[0] = b[0];
	        t.defaultTACOnline[1] = b[1];
	        t.defaultTACOnline[2] = b[2];
	        t.defaultTACOnline[3] = b[3];
	        t.defaultTACOnline[4] = b[4];
	        t.useDefaultTACOnline[0] = 0x01;
	    }
		
		if (tagDF13.getText().toString().length() != 10 && tagDF13.getText().toString().length() != 0){
			displayAlert("Error","Default TAC-Default Code must be 10 hex characters representing 5 bytes (example 0000000000), or empty if value not supported");
			return;
		}
		if (tagDF13.getText().toString().length() == 0){
	        t.defaultTACDefault[0] = 0;
	        t.defaultTACDefault[1] = 0;
	        t.defaultTACDefault[2] = 0;
	        t.defaultTACDefault[3] = 0;
	        t.defaultTACDefault[4] = 0;
	        t.useDefaultTACDefault[0] = 0;
	    }
	    else{
	    	b = getBytesFromHexString(tagDF13.getText().toString());
	        t.defaultTACDefault[0] = b[0];
	        t.defaultTACDefault[1] = b[1];
	        t.defaultTACDefault[2] = b[2];
	        t.defaultTACDefault[3] = b[3];
	        t.defaultTACDefault[4] = b[4];
	        t.useDefaultTACDefault[0] = 0x01;
	    }
	    
		if (tag9F16.getText().toString().length() != 15){
			displayAlert("Error","Merchant ID must be 15 ASCII characters.   (example 123456789012345)");
			return;
		}
		b = tag9F16.getText().toString().getBytes();
		for (int x = 0; x < 15; x++) {
	        t.merchantID[x] = b[x];
	    }
		
		if (tag9F1C.getText().toString().length() != 8){
			displayAlert("Error","Terminal ID must be 8 ASCII characters.   (example 123456789)");
			return;
		}
		b = tag9F1C.getText().toString().getBytes();
		for (int x = 0; x < 8; x++) {
	        t.terminalID[x] = b[x];
	    }
		
		if (tag9F4E.getText().toString().length() > 36){
			displayAlert("Error","Location must be less than 36 ASCII characters.");
			return;
		}
		b = tag9F4E.getText().toString().getBytes();
		for (int x = 0; x < 36; x++) {
	        if (x < tag9F4E.getText().toString().length()) {
	            t.terminalLocation[x] = b[x];
	        }
	        else{
	            t.terminalLocation[x] = 0x20;
	        }
	        
	    }
		myUniPayEMV.setTerminalData(t);
		
	}
	
	private void InitializeUI()
	{
		dlg_btnBack = (Button)findViewById(R.id.dlg_btnBack);
		dlg_btnSaveTerminal = (Button)findViewById(R.id.dlg_btnSaveTerminal);


		tag9F1A = (EditText)findViewById(R.id.tag9F1A);
		tag9F15 = (EditText)findViewById(R.id.tag9F15);
		tag9F16 = (EditText)findViewById(R.id.tag9F16);
		tag9F1C = (EditText)findViewById(R.id.tag9F1C);
		tagDF13 = (EditText)findViewById(R.id.tagDF13);
		tagDF14 = (EditText)findViewById(R.id.tagDF14);
		tagDF15 = (EditText)findViewById(R.id.tagDF15);
		tag9F4E = (EditText)findViewById(R.id.tag9F4E);
		
		dlg_btnBack.setOnClickListener(this);
		dlg_btnSaveTerminal.setOnClickListener(this);
		
		UniPayTerminalDataStruct t = myUniPayEMV.retrieveTerminalData();
		tag9F1A.setText(getHexStringFromBytes(t.terminalCountryCode));
		tag9F15.setText(getHexStringFromBytes(t.merchantCategoryCode));
		tag9F16.setText(getTextFromBytes(t.merchantID));
		tag9F1C.setText(getTextFromBytes(t.terminalID));
		tagDF13.setText(getHexStringFromBytes(t.defaultTACDefault));
		tagDF14.setText(getHexStringFromBytes(t.defaultTACDenial));
		tagDF15.setText(getHexStringFromBytes(t.defaultTACOnline));
		tag9F4E.setText(getTextFromBytes(t.terminalLocation));

		

	}
	private Button dlg_btnBack;
	private Button dlg_btnSaveTerminal;

	private EditText tag9F1A;
	private EditText tag9F15;
	private EditText tag9F16;
	private EditText tag9F1C;
	private EditText tagDF13;
	private EditText tagDF14;
	private EditText tagDF15;
	private EditText tag9F4E;

	private Window window=null;
	private IDT_Device myUniPayReader = null ; 
	private UniPayEMVDemo myMainUI = null;
	private UniPayEMV myUniPayEMV = null ;
	
	private String getHexStringFromBytes(byte []data)
    {
		if(data==null) return null;
		if(data.length<=0) 
			return null;
		StringBuffer hexString = new StringBuffer();
		String fix = null;
		for (int i = 0; i < data.length; i++) {
			fix = Integer.toHexString(0xFF & data[i]);
			if(fix.length()==1)
				fix = "0"+fix;
			hexString.append(fix);
		}
		fix = null;
		fix = hexString.toString();
		return fix;
    }
    public byte[] getBytesFromHexString(String strHexData)
	{
	    if (1==strHexData.length()%2) {
	    	return null;
	    }
	    byte[] bytes = new byte[strHexData.length()/2];
	    try{
		    for (int i=0;i<strHexData.length()/2;i++) {
		    	bytes[i] = (byte) Integer.parseInt(strHexData.substring(i*2, (i+1)*2) , 16);
		    }
	    }
	    catch(Exception ex)
	    {
	    	ex.printStackTrace();
	    	return null;
	    }
	    return bytes;
	}
    
    private String getTextFromBytes(byte []data){
    	String str = "";
		try {
			str = new String(data, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	return str;
    }
	
}
 
