package com.idtechproducts.unipayemv.demo;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;

import com.idtechproducts.device.APDUResponseStruct;
import com.idtechproducts.device.IDTMSRData;
import com.idtechproducts.device.OnReceiverListener;
import com.idtechproducts.device.ReaderInfo.CAPTURE_ENCODE_TYPE;
import com.idtechproducts.device.ReaderInfo.CAPTURE_ENCRYPT_TYPE;
import com.idtechproducts.device.ReaderInfo.DEVICE_INTERFACE_Types;
import com.idtechproducts.device.ReaderInfo.EVENT_MSR_Types;
import com.idtechproducts.device.ReaderInfo.ReaderType;
import com.idtechproducts.device.ResDataStruct;
import com.idtechproducts.device.StateList;
import com.idtechproducts.device.IDT_Device;
import com.idtechproducts.emv.UniPayEMV;
import com.idtechproducts.emv.UniPayEMV.IDTEMVData;
import com.idtechproducts.emv.UniPayEMV.MESSAGE_Types;
import com.idtechproducts.device.StructConfigParameters;
import com.idtechproducts.unipay.demo.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnKeyListener;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.text.Editable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
/*
 * 
 * File name: 	UniPayDemo.java
 * Author:		Eric.Yang
 * Time:		2013.07.21
 * 
 */

// interface UniPayReaderMsg should be implemented
// if firmware download is supported, UniPayReaderToolsMsg also needs to be implemented 
public class UniPayEMVDemo extends Activity implements  OnReceiverListener, UniPayEMV.UniPayEMVDelegate {

	// declaring the instance of the UniPayReader;
	private IDT_Device myUniPayReader = null;
	
	// declaring the instance of the myUniPayEMV;
	private UniPayEMV myUniPayEMV = null;

	private String md5 = "283fde7a8caf59be0aae55232e3e6402";//kernel .jar checksum
	private String md5ck = "8f09bee8457df294ab50a9cd328015f4";//kernel .so checksum
	public boolean _completion = false;

	private TextView connectStatusTextView; // displays status of UniPay Reader: Connected / Disconnected
	private TextView headerTextView; // short description of data displayed below
	private TextView textAreaTop;
	private EditText textAmount;
	private EditText textType;
	private EditText textLCD;
	private Button btnStartEMV;
	private Button btnCancelEMV;
	private Button btnCompleteEMV;
	private Button btnAID;
	private Button btnTerminal;
	private Button btnReceipt;
	private boolean isReaderConnected = false;
	private boolean isExitButtonPressed = false;
	private boolean isWaitingForCommandResult=false;
	private boolean isSaveLogOptionChecked = false;
	private boolean isUseAutoConfigProfileChecked = false;
	private boolean isCompletion = false;
	private boolean _hudON = false;
	//update the powerup status
	private int percent = 0;
	private long beginTime = 0;
	private long beginTimeOfAutoConfig = 0;
	private boolean waitForRemove = false;
	private boolean signatureCVM = false;
	private Map<String,byte[]> _unencryptedTags = null;
	private Map<String,byte[]> _encryptedTags = null;
	private Map<String,byte[]> _maskedTags = null;

	private String popupDialogMsg = null;
	private boolean enableSwipeCard =false;
	private boolean autoconfig_running = false;	
	private String finalReceipt = "";
	public String _currentScript = "";
	public String _currentFullScript = "";

	private String strMsrData = null;
	private byte[] flag = null;
	private byte[] msrData = null;
	private String statusText = null;
	ProgressDialog waitDialog = null;
	static boolean waitingForSwipe = false;

	public String responseCode = null;
	public String iad = null;
	public String script = null;

	

	/*****************************************	
	CREATE TABLE profiles ( 
		search_date DATETIME,
		direction_output_wave INTEGER,
		input_frequency INTEGER,
		output_frequency INTEGER,
		record_buffer_size INTEGER,
		read_buffer_size INTEGER,
		wave_direction INTEGER,
		_low INTEGER,
		_high INTEGER,
		__low INTEGER,
		__high INTEGER,
		high_threshold INTEGER,
		low_threshold INTEGER,
		device_apm_base INTEGER,
		min INTEGER,
		max INTEGER,
		baud_rate INTEGER,
		preamble_factor INTEGER,
		set_default INTEGER)
		
	)
	*****************************************/
	
	static private final int REQUEST_GET_XML_FILE = 1;
	static private final int REQUEST_GET_BIN_FILE = 2;
	static private final int REQUEST_GET_ENCRYPTED_BIN_FILE = 3;
	
	//property for the menu item.
	static final private int EXIT_IDT_APP 	= Menu.FIRST;

    

	private MenuItem itemExitApp = null;

	
	private SubMenu sub = null;
    
	private UniPayTopDialog dlgTopShow = null ;
	private UniPayTopDialog dlgSwipeTopShow = null ;


	private StructConfigParameters profile = null;
	private ProfileDatabase profileDatabase = null;
	private Handler handler = new Handler();
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	setContentView(R.layout.main);
     	
    	profileDatabase = new ProfileDatabase(this);
    	waitDialog = new ProgressDialog(this);
		waitDialog.setMessage("Processing...");
		waitDialog.setIndeterminate(true);
		waitDialog.setCancelable(false);
    	profileDatabase.initializeDB();
    	isUseAutoConfigProfileChecked = profileDatabase.getIsUseAutoConfigProfile();
    	initializeUI();
    	initializeReader();
		
    	String strManufacture = myUniPayReader.phone_getInfoManufacture();
    	String strModel = myUniPayReader.phone_getInfoModel();
    	
    	StringBuilder _strSDKVerInfo = new StringBuilder(); 
    	myUniPayReader.config_getSDKVersion(_strSDKVerInfo);
    	String strSDKVerInfo =_strSDKVerInfo.toString();
    	String strOSVerInfo = android.os.Build.VERSION.RELEASE;
		
    	textAreaTop.setText("Phone: "+strManufacture+"\n"+"Model: "+strModel+"\n"+"SDK Ver: "+strSDKVerInfo+"\nOS Version: "+strOSVerInfo);
    	String version = "N/A";
    	try {
			 version = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
		} catch (NameNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		this.setTitle("Test App: " + version + " EMV: " + UniPayEMV.EMV_VERSION );
    	// to prevent screen timeout
    	getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
	}
	@Override
	protected void onPause() {
		if(myUniPayReader!=null)
		{
			//stop swipe card when the application go to background
			myUniPayReader.stopWaitingTask();			
		}
		hideTopDialog();
		hideSwipeTopDialog();
		super.onPause();
	}
	@Override
	protected void onResume() {
		if(myUniPayReader!=null)
		{
			if(isSaveLogOptionChecked==true)
				myUniPayReader.log_setSaveLogEnable(true);
			else
				myUniPayReader.log_setSaveLogEnable(false);
		}

		isWaitingForCommandResult=false;
		super.onResume();
	}
	@Override
    protected void onDestroy() {
		myUniPayReader.release();
		profileDatabase.closeDB();
		super.onDestroy();
		if (isExitButtonPressed)
		{
			android.os.Process.killProcess(android.os.Process.myPid());
		}
    }
	
    public synchronized void onActivityResult(final int requestCode, int resultCode, final Intent data) {

        if (resultCode == Activity.RESULT_OK) {

        	String strTmpFileName = data.getStringExtra(FileDialog.RESULT_PATH);;
            if (requestCode == REQUEST_GET_XML_FILE) {
	    		
	    		if(!isFileExist(strTmpFileName))
	    		{ 
	    			headerTextView.setText("Warning");
	    			textAreaTop.setText("Please copy the XML file 'IDT_uniMagCfg.xml' into root path of SD card.");
	    			// textAreaBottom.setText("");
	    			return  ;
	    		}
	    		if (!strTmpFileName.endsWith(".xml")){
	    			headerTextView.setText("Warning");
	    			textAreaTop.setText("Please select a file with .xml file extension.");
	    			// textAreaBottom.setText("");
	    			return  ;
	    		}
	    		
	    		/////////////////////////////////////////////////////////////////////////////////
	    		// loadingConfigurationXMLFile() method may connect to server to download xml file.
	    		// Network operation is prohibited in the UI Thread if target API is 11 or above.
	    		// If target API is 11 or above, please use AsyncTask to avoid errors.
	    	    myUniPayReader.config_setXMLFileNameWithPath(strTmpFileName);
	    	    if (myUniPayReader.config_loadingConfigurationXMLFile(false)) {
		    	    headerTextView.setText("Command Info");
		    	    textAreaTop.setText("Reload XML file succeeded.");
		    	    // textAreaBottom.setText("");
	    	    }
	    	    else {
	    			headerTextView.setText("Warning");
	    			textAreaTop.setText("Please select a correct file and try again.");
	    			// textAreaBottom.setText("");
	    	    }
            } 
            else if (requestCode == REQUEST_GET_BIN_FILE)
            {
 	    		if(!isFileExist(strTmpFileName))
	    		{ 
 	    			headerTextView.setText("Warning");
 	    			textAreaTop.setText("Please copy the BIN file into the SD card root path.");
 	    			// textAreaBottom.setText("");
	    			return  ;
	    		} 
				//set BIN file
		     //   if(true==firmwareUpdateTool.setFirmwareBINFile(strTmpFileName))
		        {
		        	headerTextView.setText("Command Info");
		        	textAreaTop.setText("Set the BIN file succeeded.");
		        	// textAreaBottom.setText("");
	    		}
		      //  else
		        {
		        	headerTextView.setText("Command Info");
		        	textAreaTop.setText("Failed to set the BIN file, please check the file format.");
		        	// textAreaBottom.setText("");
		        }
            }
            else if(requestCode == REQUEST_GET_ENCRYPTED_BIN_FILE)
            {

 	    		if(!isFileExist(strTmpFileName))
	    		{ 
 	    			headerTextView.setText("Warning");
 	    			textAreaTop.setText("Please copy the BIN file into the SD card root path.");
 	    			// textAreaBottom.setText("");
	    			return  ;
	    		} 
				//set BIN file
		     //   if(true==firmwareUpdateTool.setFirmwareEncryptedBINFile(strTmpFileName))
		        {
		        	headerTextView.setText("Command Info");
		        	textAreaTop.setText("Set the Encrypted BIN file succeeded.");
		        	// textAreaBottom.setText("");
	    		}
		   //     else
		        {
		        	headerTextView.setText("Command Info");
		        	textAreaTop.setText("Failed to set the Encrypted BIN file, please check the file format.");
		        	// textAreaBottom.setText("");
		        }
            }
        } 
    }


    
    private void textLCDsetText(String str){
		
		
		final String result = str + "\n";
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	textLCD.setText(result);
       	    }
       	});
       	
	}
    
	private void appendMessageToResults(String str){
		
		
		final String result = str + "\n";
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	textAreaTop.append(result);
       	    }
       	});
       	
	}
	
	private void clearResults(){
		
		
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	textAreaTop.setText("");
       	    }
       	});
       	
	}
    

	private void _displayAlert(String title, String message){
	
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle(title);
		builder.setMessage(message);
		builder.setNegativeButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
			}
		});
		AlertDialog alert = builder.create();		
		alert.show();
	}
    
    private void displayAlert(String title, String message){
    	
    	final String _title = title;
    	final String _message = message;
    	runOnUiThread(new Runnable() {
       	    public void run() {
       	    	_displayAlert( _title,  _message);
       	    }
       	});
    	  	
    }
    public static boolean _isMulti = false;
    public static boolean _cancelLoop = false;
    
    
 
  private boolean isDeviceConnected(){
  	if (!myUniPayReader.device_isConnected()){
		displayAlert("ERROR","Device not connected");
		return false;
	}
  	return true;
  }
    private boolean allowClick = false;
    private long lStartTime = 0;
    private boolean inEMV = false;
    private void startEMV(){
    	

    	if (inEMV) return;
    	inEMV = true;
    	 _currentScript = "";
    	 _currentFullScript = "";



    	if (textAmount.getText().toString().length() == 0){
    		displayAlert("Invalid Amount","Please enter a valid amount before proceeding");
    		inEMV = false;
			return;
    	}
    	if (textType.getText().toString().length() == 0){
    		displayAlert("Invalid Type","Please enter a valid type before proceeding");
    		inEMV = false;
			return;
    	}
    	String amtString = textAmount.getText().toString();	
		float amt = Float.valueOf(amtString);
		if (amt == 0 || amt < 0){
			displayAlert("Invalid Amount","Please enter a valid amount before proceeding");
			inEMV = false;
			return;
		}
			
		
		AlertDialog.Builder alert = new AlertDialog.Builder(this);

		alert.setTitle("Authorize Amount");
	 
		alert.setMessage("Amount OK?\n"+amtString);
		textLCDsetText("Amount OK?\n"+amtString);
	
		alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
		public void onClick(DialogInterface dialog, int whichButton) {
		  
			if (!allowClick){
				inEMV = false;
				return;
			}
			allowClick = false;
			textAreaTop.setText("");
			appendMessageToResults("============================");
		    appendMessageToResults("Start Transaction");

		    Calendar c = Calendar.getInstance();
		    SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
            String d = sdf.format(c.getTime());
            
		    appendMessageToResults(d);
		    
		    appendMessageToResults("Script ID: " + _currentScript);
		    appendMessageToResults("Script: " + _currentFullScript);
		    appendMessageToResults("Amount: "+ textAmount.getText().toString());
		    appendMessageToResults("Trans Type: "+ textType.getText().toString());
			
			textLCDsetText("Processing");
			isCompletion = false;
			
			
			
			
			//if	(!_hudON) showWaitDialog();
			//_hudON = true;
			/*
			lStartTime = System.currentTimeMillis();
			myUniPayEMV.startEMVTransaction(Float.valueOf(textAmount.getText().toString()), 200, Integer.valueOf(textType.getText().toString()), null);
			*/
			//msgProcessing();
			new Thread(new Runnable() {
                public void run() {
                	try {
						Thread.sleep(500);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
                	runOnUiThread(new Runnable() {
                   	    public void run() {
                   	    	lStartTime = System.currentTimeMillis();
                			textLCDsetText("Processing");
                			isCompletion = false;
                			if	(!_hudON) showWaitDialog();
                			_hudON = true;
                			_currentScript = "";
                			_currentFullScript = "";
                			inEMV = true;
                			checkForEncryption();
                			myUniPayEMV.startEMVTransaction(Float.valueOf(textAmount.getText().toString()), 200, Integer.valueOf(textType.getText().toString()), null);
                			//handler.post(doHideTopDlg);
                   	    }
                   	});

                }
            }).start();
			
			
			
		  }
		});

		alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
		  public void onClick(DialogInterface dialog, int whichButton) {
			  if (!allowClick) return;
				allowClick = false;
			  textLCDsetText("UniPay Ready");
			  inEMV = false;
			 return;
		  }
		});
		alert.setOnCancelListener(new DialogInterface.OnCancelListener() {         
		    
		    public void onCancel(DialogInterface dialog) {
		        //do whatever you want the back key to do
		    	if (!allowClick) return;
				allowClick = false;
			  textLCDsetText("UniPay Ready");
			  inEMV = false;
			 return;
		    }
		});
		
		
			allowClick = true;
			alert.show();
		
		
    }
    

    

    
    public void doCompletion(String _responseCode, String _iad, String _script){
    	
    	
     	inEMV = false;
    	_completion = false;
    	responseCode = _responseCode;
    	iad = _iad;
    	script = _script;
    	
	    
	    
	    
	    //msgProcessing();
		new Thread(new Runnable() {
            public void run() {
            	try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
            	runOnUiThread(new Runnable() {
               	    public void run() {
               	    	UniPayEMV.EMV_COMPLETION_RESULT rc = UniPayEMV.EMV_COMPLETION_RESULT.EMV_COMPLETION_RESULT_ACCEPTED;
               		    if (responseCode.length()== 0 ) rc = UniPayEMV.EMV_COMPLETION_RESULT.EMV_COMPLETION_RESULT_UNABLE_TO_GO_ONLINE;
               		 isCompletion = true;
        			if	(!_hudON) showWaitDialog();
        			_hudON = true;
               	    	if( myUniPayEMV.completeOnlineEMVTransaction(rc, responseCode, iad, script)){
               			   textLCDsetText("AUTHORIZING");
               				appendMessageToResults("============================");
               			    appendMessageToResults("Complete Online Transaction");
               			    appendMessageToResults("Response Code = " + responseCode);
               			    appendMessageToResults("Script ID: " + _currentScript);
               			    appendMessageToResults("Script: " + _currentFullScript);
               			    appendMessageToResults("\n");
               			    
               			 _currentScript = "";
               	    	 _currentFullScript = "";
               		    //showWaitDialog();
               		   }
               		   else{
               			   textLCDsetText("UniPay Ready");
               			   appendMessageToResults("\nComplete Online Unavailable");
               		   }
            			//handler.post(doHideTopDlg);
               	    }
               	});

            }
        }).start();
	    
	    
	   
	   
		
    
    }
	private void initializeUI()
	{
		btnStartEMV = (Button)findViewById(R.id.btn_startEMV);
		btnCancelEMV = (Button)findViewById(R.id.btn_cancelEMV);
		btnCompleteEMV = (Button)findViewById(R.id.btn_completeEMV);
		btnAID = (Button)findViewById(R.id.btn_aid);
		btnTerminal = (Button)findViewById(R.id.btn_terminal);
		btnReceipt = (Button)findViewById(R.id.btn_receipt);
		textAreaTop = (TextView)findViewById(R.id.text_area_top);
		textLCD = (EditText)findViewById(R.id.txt_LCD);
		textAmount = (EditText)findViewById(R.id.txt_amount);
		textType = (EditText)findViewById(R.id.txt_type);
		connectStatusTextView = (TextView)findViewById(R.id.status_text);
		headerTextView = (TextView)findViewById(R.id.header_text);
	


		headerTextView.setText("MSR Data");
		connectStatusTextView.setText("DISCONNECTED");
		
			
		
		getWindow().setFlags(WindowManager.LayoutParams. FLAG_FULLSCREEN, WindowManager.LayoutParams. FLAG_FULLSCREEN);

		// Set Listener for "Start EMV" Button
		btnStartEMV.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {	
				if (!isDeviceConnected()) return;
					startEMV();		
					/*
					statusText = "Please connect a reader first.";
					msrData = null;
					handler.post(doUpdateStatus);	
					 */
			}  
		});  

		// Set Listener for "Cancel EMV" Button
		btnCancelEMV.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {
				if (!isDeviceConnected()) return;

				waitForCardInsert = false;
				myUniPayEMV.cancelTransaction();
				textLCDsetText("UniPay Ready");
				
			}  
		});  
		// Set Listener for "Complete EMV" Button
		btnCompleteEMV.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {
				
				if (!isDeviceConnected()) return;
				if (!_completion) return;
		     	
				if (!isWaitingForCommandResult)
				{

					
					DlgCompleteOnline myDlg = new DlgCompleteOnline (UniPayEMVDemo.this,myUniPayReader, myUniPayEMV);
					myDlg.DisplayDlg();
				}
			    
			    
			}  
		}); 
		


		// Set Listener for "AID" Button
		btnAID.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {
				if (!isWaitingForCommandResult)
				{
					DlgAID myDlg = new DlgAID (UniPayEMVDemo.this,myUniPayReader, myUniPayEMV);
					myDlg.DisplayDlg();
				}
			}  
		}); 

		// Set Listener for "Terminal" Button
		btnTerminal.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {
				if (!isWaitingForCommandResult)
				{
						DlgTerminal myDlg = new DlgTerminal (UniPayEMVDemo.this,myUniPayReader, myUniPayEMV);
						myDlg.DisplayDlg();
					
				}
			}  
		}); 	
		// Set Listener for "Receipt" Button
		btnReceipt.setOnClickListener(new OnClickListener(){  
			public void onClick(View v) {
				if (!isWaitingForCommandResult)
				{
					DlgReceipt myDlg = new DlgReceipt (UniPayEMVDemo.this, finalReceipt);
						myDlg.DisplayDlg();
					
				}
			}  
		});  		
	}
	
	private boolean bAsyncronizeLoadXML = true;
	boolean loadXMLSucceeded = true;

	public void setmAPDU(){
		myUniPayEMV.accelerateRead(true);
		//set acceleratedRead to FALSE if firmware is earlier than 1.00.10, or certification issues.
	}
	
	private void initializeReader()
	{

		if(myUniPayReader!=null){
			myUniPayReader.unregisterListen();
			myUniPayReader.release();
			myUniPayReader = null;
		}
		myUniPayReader = new IDT_Device(this,this);
			
		myUniPayReader.log_setVerboseLoggingEnable(true);
//        myUniPayReader.registerListen();
		if(myUniPayEMV!=null){
			myUniPayEMV = null;
		}
		myUniPayEMV = new UniPayEMV(this,myUniPayReader,this);

		//myUniPayEMV.useThread(false);
		getEnglishLanguageXMLFileFromRaw();

        if (isUseAutoConfigProfileChecked) {
        	myUniPayReader.registerListen();
			if (profileDatabase.updateProfileFromDB()) {
				this.profile = profileDatabase.getProfile();
				Toast.makeText(this, "AutoConfig profile has been loaded.", Toast.LENGTH_LONG).show();
				handler.post(doConnectUsingProfile);
			}
			else {
				Toast.makeText(this, "No profile found. Please run AutoConfig first.", Toast.LENGTH_LONG).show();
			}
        } else {
        	
            //Eric: 2012.03.16 Asyncronism implements when loading the XML file
            if(bAsyncronizeLoadXML)
            {
            	/*
     			new LoadConfigTask().execute();
    			sendMessage(UNIPAY_LOAD_XML_START);
     			*/
            	  new Thread(new Runnable() {
                      public void run() {
                     	  loadXMLfile();
                    	  myUniPayReader.registerListen();
                    	  //if(loadXMLSucceeded==false)handler.post(doAutoConfigProgress);	
                      }
                  }).start();

            }
            else
            {
            	loadXMLfile();
           }
        }
	}


	private static ProgressDialog pDialog	= null;
    public static final int DLG_UPDATE		= 10;
	protected Dialog onCreateDialog(int id) {
		Dialog dialog = null;
		  {
			// Progress Dialogs
			pDialog = new ProgressDialog(this);
			switch(id) {
			case DLG_UPDATE:
				pDialog.setTitle("Loading UniMag Config");
				pDialog.setMessage("Please Wait...");
				pDialog.setIndeterminate(true);
				dialog = pDialog;
				break;
			default:
				pDialog = null;
				dialog = null;
			}
		}
		
	    return dialog;
	}
	
	private void loadXMLfile(){
	
	    //load the XML configuratin file
	    String fileNameWithPath = getConfigurationFileFromRaw();
	    if(!isFileExist(fileNameWithPath)) { 
	    	fileNameWithPath = null; 
	    }        	
	    /////////////////////////////////////////////////////////////////////////////////
		// Network operation is prohibited in the UI Thread if target API is 11 or above.
		// If target API is 11 or above, please use AsyncTask to avoid errors.
	    myUniPayReader.config_setXMLFileNameWithPath(fileNameWithPath);
	    Log.d("Demo Info >>>>>","loadingConfigurationXMLFile begin.");
	    myUniPayReader.config_loadingConfigurationXMLFile(true);
	    /////////////////////////////////////////////////////////////////////////////////			sendMessage(UNIMAG_LOAD_XML_DONE);

	}
	


	private String getConfigurationFileFromRaw( ){
		return getXMLFileFromRaw("idt_unimagcfg_default.xml",R.raw.idt_unimagcfg_default);
		}
//	private String getFastAutoConfigProfileFileFromRaw( ){
		//share the same copy with the configuration file
//		return getXMLFileFromRaw("idt_auto_cfg_default.xml",R.raw.idt_auto_cfg_default);
//		}	
	private String getEnglishLanguageXMLFileFromRaw( ){
		//share the same copy with the configuration file
		return getLanguageXMLFileFromRaw("English_RSAData.xml",R.raw.english_rsadata);
		}
	private String getLanguageXMLFileFromRaw(String fileName ,int res){
		//the target filename in the application path
		String fileNameWithPath = null;
	
		String temp = fileName;
		String path = Environment.getExternalStorageDirectory().toString(); 
		fileNameWithPath = path +java.io.File.separator+ temp;

		try {
			
			if(!isFileExist(fileNameWithPath))
			{
				InputStream in = getResources().openRawResource(res);
				int length = in.available();
				byte [] buffer = new byte[length];
				in.read(buffer);    	   
				in.close();
				//deleteFile(fileNameWithPath);
				File file = new File(fileNameWithPath);
				FileOutputStream fout = new FileOutputStream(file);
				fout.write(buffer);
				fout.close();
			}
 		} catch(Exception e){
			e.printStackTrace();
			fileNameWithPath = null;
		}
		return fileNameWithPath;
	}    
	// If 'idt_unimagcfg_default.xml' file is found in the 'raw' folder, it returns the file path.
	private String getXMLFileFromRaw(String fileName ,int res){
		//the target filename in the application path
		String fileNameWithPath = null;
		fileNameWithPath = fileName;
		String newFilename = fileName;
	
		try {
			InputStream in = getResources().openRawResource(res);
			int length = in.available();
			byte [] buffer = new byte[length];
			in.read(buffer);    	   
			in.close();
			deleteFile(fileNameWithPath);
			FileOutputStream fout = openFileOutput(fileNameWithPath, MODE_PRIVATE);
			fout.write(buffer);
			fout.close();
    	   
			// to refer to the application path
			File fileDir = this.getFilesDir();
			fileNameWithPath = fileDir.getParent() + java.io.File.separator + fileDir.getName();
			fileNameWithPath += java.io.File.separator+newFilename;
	   	   
		} catch(Exception e){
			e.printStackTrace();
			fileNameWithPath = null;
		}
		return fileNameWithPath;
	}
	
    @Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
			return false;
		}
		return super.onKeyDown(keyCode, event);
	}

	@Override
	public boolean onKeyMultiple(int keyCode, int repeatCount, KeyEvent event) {
   	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
    		 
			return false;
		}	return super.onKeyMultiple(keyCode, repeatCount, event);
	}

	@Override
	public boolean onKeyUp(int keyCode, KeyEvent event) {
    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
 			return false;
		}
    	return super.onKeyUp(keyCode, event);
	}

    @Override
	public boolean onOptionsItemSelected(MenuItem item) {
    	switch(item.getItemId())
	    {
   
	    	// when the 'exit' menu item clicked
	    	case (EXIT_IDT_APP):
	    	{
	    		isExitButtonPressed = true;
        		if(myUniPayReader!=null)
        		{
        			myUniPayReader.unregisterListen();
        			myUniPayReader.release();
        		}
        		finish();
	    		break;
	    	}
	    	// If save log option is already enabled, put a check mark whenever settings menu is clicked.   
	    	
    	}
       	return super.onOptionsItemSelected(item);
	}

    @Override
	public boolean onCreateOptionsMenu(Menu menu) {
 
		itemExitApp = menu.add(0,EXIT_IDT_APP,Menu.NONE,"Exit");
		itemExitApp.setEnabled(true); 
		return super.onCreateOptionsMenu(menu);
	}


    //for UniPayReader.getAttachedReaderType()
    public ReaderType getAttachedReaderType(int UniPayUnit) {
    	switch (UniPayUnit) {
    	case StateList.uniMag2G3GPro:
    		return ReaderType.UM_OR_PRO;
    	case StateList.uniMagII:
    		return ReaderType.UM_II;
    	case StateList.uniMagShuttle:
    		return ReaderType.SHUTTLE;
    	case StateList.UniPay:
    		return ReaderType.UNIPAY;
    	case StateList.uniMagUnkown:
    	default:
    		return ReaderType.UNKNOWN;
    	}
    }
    private void showAboutInfo()
    {
		String strManufacture = myUniPayReader.phone_getInfoManufacture();
		String strModel = myUniPayReader.phone_getInfoModel();
		
		StringBuilder _strSDKVerInfo = new StringBuilder();
		myUniPayReader.config_getSDKVersion(_strSDKVerInfo);
		String strSDKVerInfo = _strSDKVerInfo.toString();
		String strXMLVerInfo = myUniPayReader.config_getXMLVersionInfo();

		headerTextView.setText("SDK Info");
		// textAreaBottom.setText("");
		String strOSVerInfo = android.os.Build.VERSION.RELEASE;
    	textAreaTop.setText("Phone: "+strManufacture+"\n"+"Model: "+strModel+"\n"+"SDK Ver: "+strSDKVerInfo+"\nXML Ver: "+strXMLVerInfo+"\nOS Version: "+strOSVerInfo);

    } 
	private Runnable device_connect = new Runnable()
	{
		public void run()
		{
			myUniPayReader.device_connect();
		}
	};	
	private Runnable device_disconnect = new Runnable()
	{
		public void run()
		{
			myUniPayReader.device_disconnect();
		}
	};	
	
;	   

	// shows messages on the popup dialog
	private void showDialog(String strTitle)
	{
		try
		{
	        AlertDialog.Builder builder = new AlertDialog.Builder(this);
	        builder.setTitle("UniPay");
	        builder.setMessage(strTitle);
	        builder.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
	
	            public void onClick(DialogInterface dialog, int which) {
	                dialog.dismiss();
	            }
	        });
	        builder.create().show();
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	};	
 
	private Runnable doShowTopDlg = new Runnable()
	{
		public void run()
		{
			showTopDialog(popupDialogMsg);
		}
	};	
	private Runnable doHideTopDlg = new Runnable()
	{
		public void run()
		{
			hideTopDialog( );
		}

	};	

	private Runnable autoComplete = new Runnable()
	{
		public void run()
		{
			//myUniPayReader.setWaitingResponseTimeout(60);
			ShowCommandResult("Completion in progress",null,null);
			doCompletion(DlgCompleteOnline._responseCode, DlgCompleteOnline._iad, DlgCompleteOnline._script);
		}
	};
		
	private Runnable doHideSwipeTopDlg = new Runnable()
	{
		public void run()
		{
			hideSwipeTopDialog( );
		}
	};
	private Runnable startEMVHandler = new Runnable()
	{
		public void run()
		{
			 startEMV();	
		}
	};
	
	private Runnable doCardInserted = new Runnable()
	{
		public void run()
		{
			headerTextView.setText("CARD INSERTED");
			if (waitForCardInsert){
				textLCDsetText("PROCESSING...");
				waitForCardInsert = false;
			}
			
		}
	};
	static int _transCounter = 0;
	static int _transCounterOk = 0;

	private Runnable doCardRemoved = new Runnable()
	{
		public void run()
		{
			headerTextView.setText("CARD REMOVED");
		}
	};
	// displays result of commands, autoconfig, timeouts, firmware update progress and results.
	private Runnable doUpdateStatus = new Runnable()
	{
		public void run()
		{
			try
			{
				textAreaTop.setText(statusText);
				headerTextView.setText("Command Info");
	    		if(msrData!=null)
	    		{
	            StringBuffer hexString = new StringBuffer();
	            
	            hexString.append("<");
	            String fix = null;
	            for (int i = 0; i < msrData.length; i++) {
	            	fix = Integer.toHexString(0xFF & msrData[i]);
	            	if(fix.length()==1)
	            		fix = "0"+fix;
	                hexString.append(fix);
	                if((i+1)%4==0&&i!=(msrData.length-1))
	                	hexString.append(' ');
	            }
	            hexString.append(">");
	            // textAreaBottom.setText(hexString.toString());
	    		}
	    		else{
	    			// textAreaBottom.setText("");
	    		}
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				
			}
		}
	};
	// displays result of commands, autoconfig, timeouts, firmware update progress and results.
	private Runnable doUpdateAutoConfigProgress = new Runnable()
	{
		public void run()
		{
			try
			{
				textAreaTop.setText(statusText);
				headerTextView.setText("Command Info");
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				
			}
		}
	};
	String strProgressInfo = "";
	// displays result of commands, autoconfig, timeouts, firmware update progress and results.
	private Runnable doUpdateAutoConfigProgressInfo = new Runnable()
	{
		public void run()
		{
			try
			{

	    		if(strProgressInfo!=null)
	    		{
	            // textAreaBottom.setText(strProgressInfo);
	    		}
	    		else{
	    			// textAreaBottom.setText("");
	    		}
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				
			}
		}
	};
	// displays data from card swiping
	
	private void adjustTextView()
	{
		int height = (textAreaTop.getHeight())/2;
		textAreaTop.setHeight(height*3/4);
	//	textAreaBottom.setHeight(height);
	}	
	// displays a connection status of UniPay reader
	static boolean needToCheckForEncryption = false;
	private Runnable doUpdateTV = new Runnable()
	{
		public void run()
		{
			String deviceType ="";
			if(dt==DEVICE_INTERFACE_Types.DEVICE_AUDIO_JACK)
				deviceType="AudioJack";
			if(dt==DEVICE_INTERFACE_Types.DEVICE_USB)
				deviceType="USB";
			
			if(!isReaderConnected){
				connectStatusTextView.setText("DISCONNECTED");
			    textLCDsetText("UniPay Not Ready");
			}
			else{
				connectStatusTextView.setText("CONNECTED ("+deviceType+")");
				textLCDsetText("UniPay Ready");
				needToCheckForEncryption = true;
			}
		}
	};

	private void checkForEncryption(){
		
		
		if (!needToCheckForEncryption) return;
		needToCheckForEncryption = false;
		
				ResDataStruct resdataStruct = new ResDataStruct();
				 myUniPayReader.device_sendCommandDirectIO("7246640000", resdataStruct);
				 byte[] res = resdataStruct.resData;
				 if (res == null) return;
				 if (res.length > 1){
					 myUniPayReader.setEncryptedUniPay(true);
				 }
				 else{
					 myUniPayReader.setEncryptedUniPay(false);
				 }			
		
		
		
		
		
		
	}
	private Runnable doUpdateToast = new Runnable()
	{
		public void run()
		{
			try{
				Context context = getApplicationContext();
				String msg = null;//"To start record the MIC.";
				if(isReaderConnected)
				{
					msg = "<<CONNECTED>>";	
					int duration = Toast.LENGTH_SHORT ;
					Toast.makeText(context, msg, duration).show();

				}
			}catch(Exception ex)
			{
				ex.printStackTrace();
			}
		}
	};
	private Runnable doConnectUsingProfile = new Runnable()
	{
		public void run() {
			if (myUniPayReader != null)
			{
				try {
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				myUniPayReader.device_connectWithProfile(profile);
			}
		}
	};
	// displays result of commands, autoconfig, timeouts, firmware update progress and results.
/*	private Runnable doAutoConfigProgress = new Runnable()
	{
		public void run()
		{
			try
			{
				Thread.sleep(300);
				//start to Auto Config the parameters
				if(myUniPayReader.startAutoConfig(getFastAutoConfigProfileFileFromRaw(),true)==true)
				{
					beginTime = getCurrentTime();
				}	
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				
			}
		}
	};	
	*/
	/***
	 * Class: UniPayTopDialog
	 * Author: Eric Yang
	 * Date: 2010.10.12
	 * Function: to show the dialog on the top of the desktop.
	 * 
	 * *****/
	private class UniPayTopDialog extends Dialog{

		public UniPayTopDialog(Context context) {
			super(context);
		}

	    @Override
		public boolean onKeyDown(int keyCode, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
				return false;
			}
			return super.onKeyDown(keyCode, event);
		}

		@Override
		public boolean onKeyMultiple(int keyCode, int repeatCount, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
	    		 
				return false;
			}	return super.onKeyMultiple(keyCode, repeatCount, event);
		}

		@Override
		public boolean onKeyUp(int keyCode, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
	 			return false;
			}
	    	return super.onKeyUp(keyCode, event);
		}
	}
	private class UniPayTopDialogYESNO extends Dialog{

		public UniPayTopDialogYESNO(Context context) {
			super(context);
		}

	    @Override
		public boolean onKeyDown(int keyCode, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
				return false;
			}
			return super.onKeyDown(keyCode, event);
		}

		@Override
		public boolean onKeyMultiple(int keyCode, int repeatCount, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
	    		 
				return false;
			}	return super.onKeyMultiple(keyCode, repeatCount, event);
		}

		@Override
		public boolean onKeyUp(int keyCode, KeyEvent event) {
	    	if ((keyCode == KeyEvent.KEYCODE_BACK||KeyEvent.KEYCODE_HOME==keyCode||KeyEvent.KEYCODE_SEARCH==keyCode)){
	 			return false;
			}
	    	return super.onKeyUp(keyCode, event);
		}
	}
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
	    
	    if (newConfig.orientation ==
	        Configuration.ORIENTATION_LANDSCAPE)
	    {
	    	//you can make sure if you would change it
	    }
	    if (newConfig.orientation ==
	        Configuration.ORIENTATION_PORTRAIT)
	    {
	    	//you can make sure if you would change it
	    }
	    if (newConfig.keyboardHidden ==
	        Configuration.KEYBOARDHIDDEN_NO)
	    {
	    	//you can make sure if you need change it
	    }
		super.onConfigurationChanged(newConfig);
	}

	private void showTopDialog(String strTitle)
	{
		hideTopDialog();
		if(dlgTopShow==null)
			dlgTopShow = new UniPayTopDialog(this);
		try
		{
			Window win = dlgTopShow.getWindow();
			win.setFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND,WindowManager.LayoutParams.FLAG_BLUR_BEHIND);
			dlgTopShow.setTitle("UniPay");
			dlgTopShow.setContentView(R.layout.dlgtopview );
			TextView myTV = (TextView)dlgTopShow.findViewById(R.id.TView_Info);
			
			myTV.setText(popupDialogMsg);
			dlgTopShow.setOnKeyListener(new OnKeyListener(){
				public boolean onKey(DialogInterface dialog, int keyCode,
						KeyEvent event) {
					if ((keyCode == KeyEvent.KEYCODE_BACK)){
						return false;
					}
					return true;
				}
			});
	        dlgTopShow.show();
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			dlgTopShow = null;
		}
	};	
	private void hideTopDialog( )
	{
		if(dlgTopShow!=null)
		{
			try{
 			dlgTopShow.hide();
 			dlgTopShow.dismiss();
			}
			catch(Exception ex)
			{
			
				ex.printStackTrace();
			}
 			dlgTopShow = null;
		}
	};	
	
	
	private void hideSwipeTopDialog( )
	{
		try
		{
			if(dlgSwipeTopShow!=null)
			{
				dlgSwipeTopShow.hide();
				dlgSwipeTopShow.dismiss();
				dlgSwipeTopShow = null;	
			}
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
	};


	public void msgToConnectDevice(){ 
		beginTime = System.currentTimeMillis();
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		popupDialogMsg = "Connect the UniPay reader...";
		handler.post(doShowTopDlg);
	}
	
	public void msgProcessing(){ 
		beginTime = System.currentTimeMillis();
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		popupDialogMsg = "Processing - Please Wait...";
		handler.post(doShowTopDlg);
	}



	// Setting a permission for user	
	public boolean getUserGrant(USER_GRANT_TYPE type, String strMessage) {
		Log.d("Demo Info >>>>> getUserGrant:",strMessage);
		Log.d("Demo Info >>>>>","getUserGrant, thread id = "+getTaskId());
		boolean getUserGranted = false;
		switch(type)
		{
		case grantConnectDevice:
			//pop up dialog to get the user grant
			getUserGranted = true;
			break;
		case grantUpdateXML:
			//pop up dialog to get the user grant
			getUserGranted = true;
			break;
		case grantOverwriteXML:
			//pop up dialog to get the user grant
			getUserGranted = true;
			break;
		case grantReportToIdtech:
			//pop up dialog to get the user grant
			getUserGranted = true;
			break;
		default:
			getUserGranted = false;
			break;
		}
		return getUserGranted;
	}

	private void uiThread(String str){
		final String result = str;
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	ShowCommandResult("EMV Transaction Response:",result,null);
       	    }
       	});
	}
	
	public void ShowCommandResult(String commandInfo,String returnInfo, byte[] cmdSourceData) {
		final String _commandInfo = commandInfo;
		final String _returnInfo = returnInfo;
		final byte[] _cmdSourceData = cmdSourceData;

		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	_ShowCommandResult(_commandInfo,_returnInfo,_cmdSourceData);
       	    }
       	});
	}
	
	
	// implementing a method onReceiveMsgCommandResult, defined in UniPayReaderMsg interface
	// receiving a message when SDK is able to parse a response for commands from the reader
	public void _ShowCommandResult(String commandInfo,String returnInfo, byte[] cmdSourceData) {
		isWaitingForCommandResult = false;
		
		
		if (commandInfo.startsWith("Please wait")){

			showWaitDialog();
		}
		/////////////
		String strResponse="";
		if(commandInfo!=null)
			strResponse +=commandInfo;
		/////////////
		if(returnInfo!=null)
		{
			strResponse+="\r\n";
			strResponse +=returnInfo;
		}
		
		if(cmdSourceData!=null)
		{
			
	 		strResponse+="\r\n";
	 		strResponse+="\r\n";
	 		StringBuffer hexString = new StringBuffer();
            
            hexString.append("<");
            String fix = null;
            for (int i = 0; i < cmdSourceData.length; i++) {
            	fix = Integer.toHexString(0xFF & cmdSourceData[i]);
            	if(fix.length()==1)
            		fix = "0"+fix;
                hexString.append(fix);
                if((i+1)%4==0&&i!=(cmdSourceData.length-1))
                	hexString.append(' ');
            }
            hexString.append(">");
			strResponse +=hexString;
 		}
		try
		{
			textAreaTop.setText(strResponse);
			headerTextView.setText("Command Info");
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			
		}
	}	
	//APDU Exchange type:
	//1: Plain text
	//2: Encryption
	//3: Force Encryption
	

	public void prepareToSendCommand(int cmdID)
	{
		isWaitingForCommandResult = true;
	/*	switch(cmdID)
		{
		//ICC LIST
		case UniPayReaderMsg.cmdDirectIO:
			statusText = " To send directIO command, wait for response.";
			break;		
		case UniPayReaderMsg.cmdPowerOnICC:
			statusText = " To Power on ICC, wait for response.";
			break;		
		case UniPayReaderMsg.cmdPowerOffICC:
			statusText = " To Power off ICC, wait for response.";
			break;
			
		case UniPayReaderMsg.cmdReviewICCGroupSetting:
			statusText = " To Review ICC Group Setting, wait for response.";
			break;
		case UniPayReaderMsg.cmdGetICCKSN:
			statusText = " To Get ICC KSN, wait for response.";
			break;
			
		case UniPayReaderMsg.cmdGetICCKeyTypeOfDUKPT:
			statusText = " To Get ICC Key Type of DUKPT, wait for response.";
			break;
			
		case UniPayReaderMsg.cmdGetICCEncryptionModeOfDUKPT:
			statusText = " To Get ICC Encryption Mode of DUKPT, wait for response.";
			break;
		case UniPayReaderMsg.cmdOpenICCNotification:
			statusText = " To Open ICC Notification, wait for response.";
			break;
			
		case UniPayReaderMsg.cmdCloseICCNotification:
			statusText = " To Close ICC Notification, wait for response.";
			break;
			
		//MSR
		case UniPayReaderMsg.cmdEnableSwipingMSRCard:
			statusText = " To Enable Swiping MSR Card, wait for response.";
			break;
		case UniPayReaderMsg.cmdCancelSwipingMSRCard:
			statusText = " To Cancel Swiping MSR Card, wait for response.";
			break;
		case UniPayReaderMsg.cmdReviewMSRSetting:
			statusText = " To Review MSR Setting, wait for response.";
			break;

			
		case UniPayReaderMsg.cmdGetVersion:
			statusText = " To Get Version, wait for response.";
			break;

		case UniPayReaderMsg.cmdGetSerialNumber:
			statusText = " To Get Serial Number, wait for response.";
			break;
		case UniPayReaderMsg.cmdReviewAudioJackSetting:
			statusText = " To Review Audio Jack Setting, wait for response.";
			break;
		default:
			break;
		}
		msrData = null;
		handler.post(doUpdateStatus);
		*/
	}
	private String getHexStringFromBytes(byte []data)
    {
		if(data==null) return null;
		if(data.length<=0) 
			return null;
		StringBuffer hexString = new StringBuffer();
		String fix = null;
		for (int i = 0; i < data.length; i++) {
			fix = Integer.toHexString(0xFF & data[i]);
			if(fix.length()==1)
				fix = "0"+fix;
			hexString.append(fix);
		}
		fix = null;
		fix = hexString.toString();
		return fix;
    }
    public byte[] getBytesFromHexString(String strHexData)
	{
	    if (1==strHexData.length()%2) {
	    	return null;
	    }
	    byte[] bytes = new byte[strHexData.length()/2];
	    try{
		    for (int i=0;i<strHexData.length()/2;i++) {
		    	bytes[i] = (byte) Integer.parseInt(strHexData.substring(i*2, (i+1)*2) , 16);
		    }
	    }
	    catch(Exception ex)
	    {
	    	ex.printStackTrace();
	    	return null;
	    }
	    return bytes;
	}
	static private String getMyStorageFilePath( ) {
		String path = null;
		if(isStorageExist())
			path = Environment.getExternalStorageDirectory().toString();
		return path;
	}
	private boolean isFileExist(String path) {
    	if(path==null)
    		return false;
	    File file = new File(path);
	    if (!file.exists()) {
	      return false ;
	    }
	    return true;
    }
	static private boolean isStorageExist() {
		//if the SD card exists
		boolean sdCardExist = Environment.getExternalStorageState().equals(android.os.Environment.MEDIA_MOUNTED);
		return sdCardExist;
	}
	private long getCurrentTime(){
		return System.currentTimeMillis();
	}
	private String getTimeInfo(long timeBase){
		int time = (int)(getCurrentTime()-timeBase)/1000;
		int hour = (int) (time/3600);
		int min = (int) (time/60);
		int sec= (int) (time%60);
		return  hour+":"+min+":"+sec;
	}
	private String getTimeInfoMs(long timeBase){
		float time = (float)(getCurrentTime()-timeBase)/1000;
		String strtime = String.format("%03f",time);
		return  strtime;
	}
	public void swipeMSRData(IDTMSRData card) {
		// TODO Auto-generated method stub
    	if (waitingForSwipe == false) return;
    	waitingForSwipe = false;
    	textLCDsetText("UniPay Ready");
    	String str = new String();
    	if( card.event == EVENT_MSR_Types.EVENT_MSR_CARD_DATA ||card.event == EVENT_MSR_Types.EVENT_MSR_DATA_ERROR) 
    	{
    		int len = card.cardData.length;
    		int i = 0;
    		str = "CardData:\r\n";
			for(i = 0; i < len; i++)
			{
				str += String.format("%02x ", card.cardData[i]);
			} 
			if(card.track1 != "")
			{
				str += "\r\nTrack1 data:\r\n";
				str += card.track1;
			}
			if(card.track2 != "")
			{
				str += "\r\nTrack2 data:\r\n";
				str += card.track2;
			}
			if(card.track3 != "")
			{
				str += "\r\nTrack3 data:\r\n";
				str += card.track3;
			}
			len = card.encTrack1.length;
			if(len > 0)
			{
				str += "\r\nTrack1 encrypted data:\r\n";
				for(i = 0; i < len; i++)
				{
					str += String.format("%02X", card.encTrack1[i]);
				}
			}
			len = card.encTrack2.length;
			if(len > 0)
			{
				str += "\r\nTrack2 encrypted data:\r\n";
				for(i = 0; i < len; i++)
				{
					str += String.format("%02X", card.encTrack2[i]);
				} 
			}
			len = card.encTrack3.length;
			if(len > 0)
			{
				str += "\r\nTrack3 encrypted data:\r\n";
				for(i = 0; i < len; i++)
				{
					str += String.format("%02X", card.encTrack3[i]);
				} 
			}
			len = card.KSN.length;
			if(len > 0)
			{
				str += "\r\nKSN:";
				for(i = 0; i < len; i++)
				{
					str += String.format("%02x ", card.KSN[i]);
				} 	
			}
			str += "\r\nCard Type:";
			if(card.cardType == CAPTURE_ENCODE_TYPE.CAPTURE_ENCODE_TYPE_ISOABA)
				str += String.format("ISO 7813/ISO 4909/ABA format.");
			else if(card.cardType == CAPTURE_ENCODE_TYPE.CAPTURE_ENCODE_TYPE_AAMVA)
				str += String.format("AAMVA format.");
			else if(card.cardType == CAPTURE_ENCODE_TYPE.CAPTURE_ENCODE_TYPE_Raw)
				str += String.format("Raw; un-decoded format.");
			else if(card.cardType == CAPTURE_ENCODE_TYPE.CAPTURE_ENCODE_TYPE_JisI_II)
				str += String.format("JIS I or JIS II.");
			else
				str += String.format("Other format.");
			str += "\r\nEncode Status:";		
			str += String.format("%02x ", card.captureEncodeStatus);
			str += "\r\nEncrypt Type:";		
			if(card.captureEncryptType == CAPTURE_ENCRYPT_TYPE.CAPTURE_ENCRYPT_TYPE_TDES)
				str += String.format("TDES");
			if(card.captureEncryptType == CAPTURE_ENCRYPT_TYPE.CAPTURE_ENCRYPT_TYPE_AES)
				str += String.format("AES");
			if(card.serialNumber != "")
			{
				str += "\r\nReader Serial Number:";
				str += card.serialNumber;
			}
	//		if (D) 
	 //   		Log.e(TAG, "++ CardSwipe ++");  
			 
    	}
    	else if(card.event == EVENT_MSR_Types.EVENT_MSR_BACKSPACE_KEY)
    		str = "Press Backspace Key.";
    	else if(card.event == EVENT_MSR_Types.EVENT_MSR_CANCEL_KEY)
    		str = "Press Cancel Key.";
    	else if(card.event == EVENT_MSR_Types.EVENT_MSR_ENTER_KEY)
    		str = "Press Enter Key.";
    	else
    	{
    		str = "Swipe Card error, error code is ";
    		str += String.format("%02X %02X ", card.cardData[0],card.cardData[1]);
    	}
 		ShowCommandResult("MSR Card Data:",str,null);
	
 		inEMV = false;
 		enableSwipeCard = true;
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);	
    	
 //   	strCard = str;
//		mHandler.post(m_CardRunnable); 
    		
	}
	private String getAdviceMessage(byte code)
	{
		switch (code)
		{
		case 0x00:
			return "";
		case 0x01:
			return "(Advice)";
		case 0x02:
			return "(reversal)";
		case 0x03:
			return "(Advice and Reversal)";
			default:
				return "";
		}
	}
	public void emvTransactionData(EMV_RESULT_CODE_Types resultCode, byte withAdvice,
			byte[] resultTags, int errorCode) {
		// TODO Auto-generated method stub

		// TODO Auto-generated method stub
		String str = new String();
		int i = 0;
		if(errorCode == 0)
		{	
			str = "Response Code:\r\n";
			if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_OFFLINE_APPROVED)
			{
				str += "Offline approved,accept the offline transaction."+getAdviceMessage(withAdvice);
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_OFFLINE_DECLINED)
			{
				str += "Offline declined,decline the offline transaction."+getAdviceMessage(withAdvice);
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED)
			{
				str += "Approved,accept the online transaction."+getAdviceMessage(withAdvice);
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_DECLINED)
			{
				str += "Declined,decline the online transaction."+getAdviceMessage(withAdvice);
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_GO_ONLINE)
			{
				
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_CALL_YOUR_BANK)
			{
				str += "Call your bank.";
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_NOT_ACCEPTED)
			{
				str += "Not Accept,ICC didn't accepted transaction.";
			}
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_USE_MAGSTRIPE)
			{
				str += "USE MAGSTRIEP. Will get the MSR card data from the message 'swipeMSRData'.";
			}			
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_TIME_OUT)
			{
				str += "EMV Transaction Time Out.";
			}	
			else if(resultCode == EMV_RESULT_CODE_Types.EMV_RESULT_CODE_TRANSACTION_SUCCESS)
			{
				
			}
			else
			{
				str += "Failed,transaction terminate.";
				
			}


			str += "\r\n\r\nReturn TLVs data from ICC card:\r\n";
			
			for(i = 0; i < resultTags.length; i++)			
			{
				str += String.format("%02x ", resultTags[i]);
			} 		
		}
		else
		{
			str = String.format("EMV transaction unsuccessfully. res = 0x%02X", errorCode&0xFFFF);
		}
		ShowCommandResult("EMV Transaction Response:",str,null);
//		strCard = str;
//		mHandler.post(m_CardRunnable);  
			
	}
	public void deviceConnected() {
		// TODO Auto-generated method stub
		isReaderConnected = true;
		if(percent==0)
		{
			if(profile!=null)
			{
				if(profile.getModelNumber().length()>0)
					statusText = "Now the UniPay Unit is connected.("+getTimeInfoMs(beginTime)+"s, with profile "+profile.getModelNumber()+")";
				else statusText = "Now the UniPay Unit is connected.("+getTimeInfoMs(beginTime)+"s)";
			}
			else
				statusText = "Now the UniPay Unit is connected."+" ("+getTimeInfoMs(beginTime)+"s)";
		}
		else
		{
			if(profile!=null)
				statusText = "Now the UniPay Unit is connected.("+getTimeInfoMs(beginTime)+"s, "+"Profile found at "+percent +"% named "+profile.getModelNumber()+",auto config last " +getTimeInfoMs(beginTimeOfAutoConfig)+"s)";
			else
				statusText = "Now the UniPay Unit is connected."+" ("+getTimeInfoMs(beginTime)+"s, "+"Profile found at "+percent +"%,auto config last " +getTimeInfoMs(beginTimeOfAutoConfig)+"s)";
			percent = 0;
		}
		myUniPayReader.icc_enableNotification(true);
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		handler.post(doUpdateTV);
		handler.post(doUpdateToast);
		msrData = null;
		handler.post(doUpdateStatus);	
		handler.post(doUpdateAutoConfigProgressInfo);

		
	}
	public void deviceDisconnected() {
		// TODO Auto-generated method stub

		percent=0;
		strProgressInfo=null;
		isReaderConnected = false;
		isWaitingForCommandResult=false;
		autoconfig_running=false;
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		handler.post(doUpdateTV);
		showAboutInfo();
			
	}
	public void timeout(String msgInfo) {
		// TODO Auto-generated method stub
		isWaitingForCommandResult=false;
		enableSwipeCard = true;
		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		statusText = msgInfo+"("+getTimeInfo(beginTime)+")";
		msrData = null;
		handler.post(doUpdateStatus);
			
	}
	public void AutoConfigCompleted(StructConfigParameters profile) {
		Log.d("Demo Info >>>>> AutoConfigCompleted" ,"A profile has been found, trying to connect...");
		autoconfig_running = false;
		beginTimeOfAutoConfig = beginTime;
		this.profile = profile;
		profileDatabase.setProfile(profile);
		profileDatabase.insertResultIntoDB();
		handler.post(doConnectUsingProfile);
	}
	public void AutoConfigProgress(int progressValue) {
		Log.d("Demo Info >>>>> AutoConfigProgress" ,"v = "+progressValue);
		percent = progressValue;
		statusText = "Searching the configuration automatically, "+progressValue+"% finished."+"("+getTimeInfo(beginTime)+")";
		msrData = null;
		beginTimeOfAutoConfig = beginTime;
		handler.post(doUpdateAutoConfigProgress);
		
	}

	public void ICCNotifyInfo(byte[] dataNotify, String strMessage) {
		// TODO Auto-generated method stub
		// TODO Auto-generated method stub
		String strHexResp = getHexStringFromBytes(dataNotify);
 		Log.d("Demo Info >>>>>","dataNotify="+ strHexResp);

		msrData=null;

		if (strHexResp.toUpperCase().startsWith("0202004E00") || strHexResp.toUpperCase().startsWith("0202004E10")){
			//Card Removed
			if (waitForRemove){
				textLCDsetText("UniPay Ready");
				waitForRemove = false;
			}
			handler.post(doCardRemoved);
			
		}
		else if (strHexResp.toUpperCase().startsWith("0202004E01") || strHexResp.toUpperCase().startsWith("0202004E11")){
			//Card Inserted
			handler.post(doCardInserted);
			
		}
		
		/*
		statusText = "ICC Notification Info: "+strMessage+"\n"+"Resp: "+strHexResp;

		handler.post(doHideTopDlg);
		handler.post(doHideSwipeTopDlg);
		handler.post(doUpdateStatus);
		*/		
	}
	public void LoadXMLConfigFileInfo(int index, String strMessage) {
		isWaitingForCommandResult = false;
		Log.d("Demo Info >>>>>","onReceiveMsgFailureInfo,index = "+index+", thread id = "+getTaskId());
		// If AutoConfig found a profile before and saved into db, then retreive it and connect.
		if (profileDatabase.updateProfileFromDB()) {
			this.profile = profileDatabase.getProfile();
    	//	showAboutInfo();
			handler.post(doConnectUsingProfile);
		} else {
			statusText = "Failure index: "+index+", message: "+strMessage;
			statusText += "\nPlease do the Auto configure searching in the settings menu.";
//			statusText = "Searching the profile to connect the reader...";
			msrData = null;
			handler.post(doUpdateStatus);
//			loadXMLSucceeded = false;
	//		}
			//Cannot support current phone in the XML file.
				

		}
	}

	public void msgAudioVolumeAjustFailed(String strMessage) {
		// TODO Auto-generated method stub
		isWaitingForCommandResult = false;
		statusText = strMessage;
		statusText += "\n\nThe suggestion is that you need allow the system to raise the media volume above recommended level." +
				"\n\nYou can open the play music application and press the volume up button when the reader or headset plugged in." +
				"\n\nIt will popup the dialog to warning the high volume may damage your hearing, so just press OK because the reader need the loud level."+
				"\n\nAfter get this permission, then reopen the Demo application.";
		
			msrData = null;
			handler.post(doUpdateStatus);
	}
	
	private String sdkError(int code){
		switch (code){
		case 0x0000: return "No error, beginning task";
		case 0x0001: return "No response from reader";
		case 0x0002: return "Invalid response data";
		case 0x0003: return "Time out for task or CMD";
		case 0x0004: return "Wrong parameter";
		case 0x0005: return "SDK is doing MSR or ICC task";
		case 0x0006: return "SDK is doing PINPad task";
		case 0x0007: return "SDK is doing Other task";
		case 0x0008: return "err response or data";
		case 0x0009: return " no reader attached";
		case 0x000A: return "did connection";
		case 0x000B: return "mono audio is enabled";
		case 0x000C: return "audio volume is too low";
		case 0x000D: return "task or CMD be canceled";
		case 0x0300: return "Key Type(TDES) of Session Key is not same as the related Master Key.";
		case 0x0400: return "Related Key was not loaded.";
		case 0x0500: return "Key Same.";
		case 0x0501: return "Key is all zero";
		case 0x0502: return "TR-31 format error";
		case 0x0702: return "PAN is Error Key.";
		case 0x0705: return "No Internal MSR PAN (or Internal MSR PAN is erased timeout)";
		case 0x0D00: return "This Key had been loaded.";
		case 0x0E00: return "Base Time was loaded.";
		case 0x0F00: return "Encryption Or Decryption Failed.";
		case 0x1000: return "Battery Low Warning (It is High Priority Response while Battery is Low.)";
		case 0x1800: return "Send “Cancel Command” after send “Get Encrypted PIN” &”Get Numeric “& “Get Amount”";
		case 0x1900: return "Press “Cancel” key after send “Get Encrypted PIN” &”Get Numeric “& “Get Amount”";
		case 0x30FF: return "Security Chip is not connect";
		case 0x3000: return "Security Chip is deactivation & Device is In Removal Legally State.";
		case 0x3101: return "Security Chip is activation &  Device is In Removal Legally State.";
		case 0x5500: return "No Admin DUKPT Key.";
		case 0x5501: return "Admin  DUKPT Key STOP.";
		case 0x5502: return "Admin DUKPT Key KSN is Error.";
		case 0x5503: return "Get Authentication Code1 Failed.";
		case 0x5504: return "Validate Authentication Code Error.";
		case 0x5505: return "Encrypt or Decrypt data failed.";
		case 0x5506: return "Not Support the New Key Type.";
		case 0x5507: return "New Key Index is Error.";
		case 0x5508: return "Step Error.";
		case 0x5509: return "KSN Error.";
		case 0x550A: return "MAC Error.";
		case 0x550B: return "Key Usage Error.";
		case 0x550C: return "Mode Of Use Error.";
		case 0x550F: return "Other Error.";
		case 0x6000: return "Save or Config Failed / Or Read Config Error.";
		case 0x6200: return "No Serial Number.";
		case 0x6900: return "Invalid Command - Protocol is right, but task ID is invalid.";
		case 0x6A01: return "Unsupported Command – Protocol and task ID are right, but command is invalid – In this State";
		case 0x6A00: return "Unsupported Command - Protocol and task ID are right, but command is invalid.";
		case 0x6B00: return "Unknown parameter in command - Protocol task ID and command are right, but parameter is invalid.";
		case 0x6C00: return "Unknown parameter in command – Protocol task ID and command are right, but length is out of the requirement.";
		case 0x7200: return "Device is suspend (MKSK suspend or press password suspend).";
		case 0x7300: return "PIN DUKPT is STOP (21 bit 1).";
		case 0x7400: return "Device is Busy.";
		case 0xE100: return "Can not enter sleep mode";
		case 0xE200: return "File has existed";
		case 0xE300: return "File has not existed";
		case 0xE313: return "IO line low -- Card error after session start";
		case 0xE400: return "Open File Error";
		case 0xE500: return "SmartCard Error";
		case 0xE600: return "Get MSR Card data is error";
		case 0xE700: return "Command time out";
		case 0xE800: return "File read or write is error";
		case 0xE900: return "Active 1850 error!";
		case 0xEA00: return "Load bootloader error";
		case 0xEF00: return "Protocol Error- STX or ETX or check error.";
		case 0xEB00: return "Picture is not exist";
		case 0x2C02: return "No Microprocessor ICC seated";
		case 0x2C06: return "no card seated to request ATR";
		case 0x2D01: return "Card Not Supported,";
		case 0x2D03: return "Card Not Supported, wants CRC";
		case 0x690D: return "Command not supported on reader without ICC support";
		case 0x8100: return "ICC error time out on power-up";
		case 0x8200: return "invalid TS character received - Wrong operation step";
		case 0x8300: return "No Card Data";
		case 0x8400: return "TriMagII no Response";
		case 0x8500: return "pps confirmation error";
		case 0x8600: return "Unsupported F, D, or combination of F and D";
		case 0x8700: return "protocol not supported EMV TD1 out of range";
		case 0x8800: return "power not at proper level";
		case 0x8900: return "ATR length too long";
		case 0x8B01: return "EMV invalid TA1 byte value";
		case 0x8B02: return "EMV TB1 required";
		case 0x8B03: return "EMV Unsupported TB1 only 00 allowed";
		case 0x8B04: return "EMV Card Error, invalid BWI or CWI";
		case 0x8B06: return "EMV TB2 not allowed in ATR";
		case 0x8B07: return "EMV TC2 out of range";
		case 0x8B08: return "EMV TC2 out of range";
		case 0x8B09: return "per EMV96 TA3 must be > 0xF";
		case 0x8B10: return "ICC error on power-up";
		case 0x8B11: return "EMV T=1 then TB3 required";
		case 0x8B12: return "Card Error, invalid BWI or CWI";
		case 0x8B13: return "Card Error, invalid BWI or CWI";
		case 0x8B17: return "EMV TC1/TB3 conflict*";
		case 0x8B20: return "EMV TD2 out of range must be T=1";
		case 0x8C00: return "TCK error";
		case 0xA304: return "connector has no voltage setting";
		case 0xA305: return "ICC error on power-up invalid (SBLK(IFSD) exchange";
		case 0xE301: return "ICC error after session start";
		case 0xFF00: return "Request to go online";
		case 0xFF01: return "EMV: Accept the offline transaction";
		case 0xFF02: return "EMV: Decline the offline transaction";
		case 0xFF03: return "EMV: Accept the online transaction";
		case 0xFF04: return "EMV: Decline the online transaction";
		case 0xFF05: return "EMV: Application may fallback to magstripe technology";
		case 0xFF06: return "EMV: ICC detected tah the conditions of use are not satisfied";
		case 0xFF07: return "EMV: ICC didn't accept transaction";
		case 0xFF08: return "EMV: Transaction was cancelled";
		case 0xFF09: return "EMV: Application was not selected by kernel or ICC format error or ICC missing data error";
		case 0xFF0A: return "EMV: Transaction is terminated";
		case 0xFF0B: return "EMV: Other EMV Error";
		case 0xFFFF: return "NO RESPONSE";
		case 0xF002: return "ICC communication timeout";
		case 0xF003: return "ICC communication Error";
		case 0xF00F: return "ICC Card Seated and Highest Priority, disable MSR work request";
		case 0xF200: return "AID List / Application Data is not exist";
		case 0xF201: return "Terminal Data is not exist";
		case 0xF202: return "TLV format is error";
		case 0xF203: return "AID List is full";
		case 0xF204: return "Any CA Key is not exist";
		case 0xF205: return "CA Key RID is not exist";
		case 0xF206: return "CA Key Index it not exist";
		case 0xF207: return "CA Key is full";
		case 0xF208: return "CA Key Hash Value is Error";
		case 0xF209: return "Transaction  format error";
		case 0xF20A: return "The command will not be processing";
		case 0xF20B: return "CRL is not exist";
		case 0xF20C: return "CRL number  exceed max number";
		case 0xF20D: return "Amount,Other Amount,Trasaction Type  are  missing";
		case 0xF20E: return "The Identification of algorithm is mistake";
		case 0xF20F: return "No Financial Card";
		case 0xF210: return "In Encrypt Result state, TLV total Length is greater than Max Length";
		case 0x1001: return "INVALID ARG";
		case 0x1002: return "FILE_OPEN_FAILED";
		case 0x1003: return "FILE OPERATION_FAILED";
		case 0x2001: return "MEMORY_NOT_ENOUGH";
		case 0x3002: return "SMARTCARD_FAIL";
		case 0x3003: return "SMARTCARD_INIT_FAILED";
		case 0x3004: return "FALLBACK_SITUATION";
		case 0x3005: return "SMARTCARD_ABSENT";
		case 0x3006: return "SMARTCARD_TIMEOUT";
		case 0x5001: return "EMV_PARSING_TAGS_FAILED";
		case 0x5002: return "EMV_DUPLICATE_CARD_DATA_ELEMENT";
		case 0x5003: return "EMV_DATA_FORMAT_INCORRECT";
		case 0x5004: return "EMV_NO_TERM_APP";
		case 0x5005: return "EMV_NO_MATCHING_APP";
		case 0x5006: return "EMV_MISSING_MANDATORY_OBJECT";
		case 0x5007: return "EMV_APP_SELECTION_RETRY";
		case 0x5008: return "EMV_GET_AMOUNT_ERROR";
		case 0x5009: return "EMV_CARD_REJECTED";
		case 0x5010: return "EMV_AIP_NOT_RECEIVED";
		case 0x5011: return "EMV_AFL_NOT_RECEIVED";
		case 0x5012: return "EMV_AFL_LEN_OUT_OF_RANGE";
		case 0x5013: return "EMV_SFI_OUT_OF_RANGE";
		case 0x5014: return "EMV_AFL_INCORRECT";
		case 0x5015: return "EMV_EXP_DATE_INCORRECT";
		case 0x5016: return "EMV_EFF_DATE_INCORRECT";
		case 0x5017: return "EMV_ISS_COD_TBL_OUT_OF_RANGE";
		case 0x5018: return "EMV_CRYPTOGRAM_TYPE_INCORRECT";
		case 0x5019: return "EMV_PSE_NOT_SUPPORTED_BY_CARD";
		case 0x5020: return "EMV_USER_SELECTED_LANGUAGE";
		case 0x5021: return "EMV_SERVICE_NOT_ALLOWED";
		case 0x5022: return "EMV_NO_TAG_FOUND";
		case 0x5023: return "EMV_CARD_BLOCKED";
		case 0x5024: return "EMV_LEN_INCORRECT";
		case 0x5025: return "CARD_COM_ERROR";
		case 0x5026: return "EMV_TSC_NOT_INCREASED";
		case 0x5027: return "EMV_HASH_INCORRECT";
		case 0x5028: return "EMV_NO_ARC";
		case 0x5029: return "EMV_INVALID_ARC";
		case 0x5030: return "EMV_NO_ONLINE_COMM";
		case 0x5031: return "TRAN_TYPE_INCORRECT";
		case 0x5032: return "EMV_APP_NO_SUPPORT";
		case 0x5033: return "EMV_APP_NOT_SELECT";
		case 0x5034: return "EMV_LANG_NOT_SELECT";
		case 0x5035: return "EMV_NO_TERM_DATA";
		case 0x6001: return "CVM_TYPE_UNKNOWN";
		case 0x6002: return "CVM_AIP_NOT_SUPPORTED";
		case 0x6003: return "CVM_TAG_8E_MISSING";
		case 0x6004: return "CVM_TAG_8E_FORMAT_ERROR";
		case 0x6005: return "CVM_CODE_IS_NOT_SUPPORTED";
		case 0x6006: return "CVM_COND_CODE_IS_NOT_SUPPORTED";
		case 0x6007: return "NO_MORE_CVM";
		case 0x6008: return "PIN_BYPASSED_BEFORE";
		case 0x7001: return "PK_BUFFER_SIZE_TOO_BIG";
		case 0x7002: return "PK_FILE_WRITE_ERROR";
		case 0x7003: return "PK_HASH_ERROR";
		case 0x8001: return "NO_CARD_HOLDER_CONFIRMATION";
		case 0x8002: return "GET_ONLINE_PIN";
		case 0xD000: return "Data not exist";
		case 0xD001: return "Data access error";
		case 0xD100: return "RID not exist";
		case 0xD101: return "RID existed";
		case 0xD102: return "Index not exist";
		case 0xD200: return "Maximum exceeded";
		case 0xD201: return "Hash error";
		case 0xD205: return "System Busy";
		case 0x0E01: return "Unable to go online";
		case 0x0E02: return "Technical Issue";
		case 0x0E03: return "Declined";
		case 0x0E04: return "Issuer Referral transaction";
		case 0x0F01: return "Decline the online transaction";
		case 0x0F02: return "Request to go online";
		case 0x0F03: return "Transaction is terminated";
		case 0x0F05: return "Application was not selected by kernel or ICC format error or ICC missing data error";
		case 0x0F07: return "ICC didn't accept transaction";
		case 0x0F0A: return "Application may fallback to magstripe technology";
		case 0x0F0C: return "Transaction was cancelled";
		case 0x0F0D: return "Timeout";
		case 0x0F0F: return "Other EMV Error";
		case 0x0F10: return "Accept the offline transaction";
		case 0x0F11: return "Decline the offline transaction";
		case 0x0F21: return "ICC detected tah the conditions of use are not satisfied";
		case 0x0F22: return "No app were found on card matching terminal configuration";
		case 0x0F23: return "Terminal file does not exist";
		case 0x0F24: return "CAPK file does not exist";
		case 0x0F25: return "CRL Entry does not exist";
		case 0x0FFE: return "Return code when blocking is disabled";
		case 0x0FFF: return "Return code when command is not applicable on the selected device";
		}
		
		return "Unknown Error";
	}
	
	static String alertTitle = "";
	static String alertBody = "";
	static DialogInterface dialog;
	AlertDialog confirmAlert;
	
	private void confirmApp(){
		 confirmAlert = new AlertDialog.Builder(this).create();

		confirmAlert.setTitle(alertTitle);
	 
		confirmAlert.setMessage(alertBody);

		// Set an EditText view to get user input 
		final EditText input = new EditText(this);
		input.setText("0");
		confirmAlert.setView(input);

		confirmAlert.setButton(DialogInterface.BUTTON_POSITIVE,"Ok", new DialogInterface.OnClickListener() {
		public void onClick(DialogInterface dialog, int whichButton) {
		  Editable value = input.getText();
		  myUniPayEMV.confirmApplication(Integer.valueOf(value.toString()));
		  showWaitDialog();
		  }
		});

		confirmAlert.setButton(DialogInterface.BUTTON_NEGATIVE,"Cancel", new DialogInterface.OnClickListener() {
		  public void onClick(DialogInterface dialog, int whichButton) {
			  myUniPayEMV.confirmApplicationCancel();
		  }
		});


			confirmAlert.show();
		
		
	}
	
	public void confirmApplicationSelection(Vector<String> labelArray, boolean tryAgain) {
		hideWaitDialog();
		
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	waitDialog.hide();
       	    }
       	});
		
		StringBuilder sb = new StringBuilder();
		for (int x = 0; x < labelArray.size(); x++) {
	        sb.append(String.valueOf(x)+": " + labelArray.elementAt(x));
	        if (x < labelArray.size()-1) {
	            sb.append("\n");
	        }
	    }
		
		
		if (tryAgain) {
			alertTitle = "Please Try Again: Select #";
	    }
	    else{
	    	alertTitle = "Please Select App Index #";
	    }
		
		alertBody = sb.toString();
		
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	confirmApp();
       	    }
       	});
		
		
	}
	
	
	private void hideWaitDialog(){
		//make sure called on main UI Thread
		if	(!_hudON) return;
		_hudON = false;
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	waitDialog.hide();
       	    }
       	});
	}
	
	private void showWaitDialog(){
		//make sure called on main UI Thread
		if	(_hudON) return;
		_hudON = true;
		runOnUiThread(new Runnable() {
       	    public void run() {
       	    	waitDialog.show();
       	    }
       	});
	}
	
	private String mapDescription(Map <String,byte[]> tags){
		if (tags == null) return "";
		StringBuilder sb = new StringBuilder();
		for (Map.Entry<String, byte[]> entry : tags.entrySet())
		{
			sb.append(entry.getKey() + ": " + getHexStringFromBytes(entry.getValue()));
			sb.append("\n");
		}
		return sb.toString();

	}
	
	

	
	public void emvTransactionData(IDTEMVData emvData, UniPayEMV.EMV_RESULT_CODE_Types errorCode, boolean performReversal) {
		signatureCVM = false;
		byte[] b = {0};
		if (emvData != null){
			if (emvData.unencryptedTags != null){
				b = emvData.unencryptedTags.get("9F27");
			    if (b[0] == 0x01) {
			        
			        appendMessageToResults("ERROR: SERVICE NOT ALLOWED");
			        isCompletion = false;
			        hideWaitDialog();
			        displayAlert("NOT ACCEPTED","Service Not Allowed");
			        textLCDsetText("Not Accepted");
			        inEMV = false;
			        return;
			    }
			}
		}
		
	    
	    if (performReversal) {
	        appendMessageToResults("WARNING: TRANSACTIONS WAS APPROVED ONLINE, BUT TERMINAL DECLINED. PLEASE REVERSE/VOID ONLINE APPROVAL FOR THIS TRANSACTION");
	    }
	    
	    boolean isError =  errorCode.toString().startsWith("EMV_RESULT_CODE_ERROR");
	    		
	    if (!isError) {
	        if (isCompletion) {
	            appendMessageToResults("");
	            appendMessageToResults("GENERATE AC2 RESULTS");
	            appendMessageToResults("Financial Transaction Confirmation:");
	        }
	        else{
	        	appendMessageToResults("");
	            appendMessageToResults("GENERATE AC1 RESULTS");
	           
	        }
	    }
	    else {
	       appendMessageToResults("ERROR: TRANSACTION TERMINATED");
	        textLCDsetText("Transaction Terminated");
	        if (errorCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_ERROR_EMV_SERVICE_NOT_ALLOWED) {
	        	textLCDsetText("NOT ACCEPTED");
	        }
	        appendMessageToResults("Result = " + errorCode.toString());
	       
	        if (confirmAlert != null) {
	        	if (confirmAlert.isShowing()) confirmAlert.dismiss();;
	        }
	        

	        isCompletion = false;
	        hideWaitDialog();

	        displayAlert("TRANSACTION TERMINATED",errorCode.toString());
	        inEMV = false;
	        return;
	    }
	    
	    
	   
	    
	    

	    
	    if ((errorCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_GO_ONLINE) || (b[0] == 0x88) || (b[0] == 0x8B) || (b[0] == 0x8A)) {
	    	 appendMessageToResults("Financial Transaction Request:");
	    	 _completion = true;
	    	
	    		textLCDsetText("GO ONLINE");
		        _unencryptedTags = emvData.unencryptedTags;	        
		        _maskedTags = emvData.maskedTags;	        
		        _encryptedTags = emvData.encryptedTags;	        
		        hideWaitDialog();
		        displayAlert("RESULT",errorCode.toString());
		        
	    		    	
	    }
	    else{
	    	byte cvm[] = null;
	    	byte tvr[] = null;
	    	byte tsi[] = null;
	    	if (emvData != null){
	    	if (emvData.unencryptedTags != null){
	    		cvm = emvData.unencryptedTags.get("9F34");
	    		if (cvm.length > 1){
	    			if (cvm[0] == 0x1e || cvm[0] == 0x5e ) signatureCVM = true;
	    		}
	    		tvr = emvData.unencryptedTags.get("95");
	    		tsi = emvData.unencryptedTags.get("9B");
	    	}
	    	}
	    	String cvmString = "";
	    	String tvrString = "";
	    	String tsiString = "";
	    	if	(cvm != null) cvmString = getHexStringFromBytes(cvm);
	    	if	(tvr != null) tvrString = getHexStringFromBytes(tvr);
	    	if	(tsi != null) tsiString = getHexStringFromBytes(tsi);
	    			
	    	
	        hideWaitDialog();
	           // [self printReceipt:(int)emvData.resultCode tags:emvData.unencryptedTags];
	        
	        finalReceipt="";
	        if (emvData != null){
		    	if (emvData.unencryptedTags != null){
		    		_unencryptedTags = emvData.unencryptedTags;	        
			        _maskedTags = emvData.maskedTags;	        
			        _encryptedTags = emvData.encryptedTags;	
		    		finalReceipt = getReceipt(errorCode,emvData.unencryptedTags);
		    	}
	        }
	        
	        
	            String results = "SUCCESS - TC";
	            _transCounterOk++;
	        textLCDsetText("APPROVED");
	            if ((b[0] & 0xf0) == 0) {
	                results = "DECLINE - AAC";
	                textLCDsetText("DECLINED");
	               if (!isCompletion) appendMessageToResults("Financial Transaction Confirmation:");
	            }
	       
	       
	            
	             final String _results = results;
	             final String body = "TVR: " + tvrString + "\nTSI: " + tsiString + "\nCVM: " + cvmString;
	       
	            
	            	   
	            	 runOnUiThread(new Runnable() {
	 	           	    public void run() {
	 	           	    
	 	           	    	receiptDialog(_results,body);
	 	           	    }
	 	           	});	
	                        
	        
	    }
	   
	    if (emvData != null){
			if (emvData.unencryptedTags != null){
				Map<String, byte[]> treeMap = new TreeMap<String, byte[]>(emvData.unencryptedTags);
				appendMessageToResults("Tags:\n" + mapDescription(treeMap));
			}
			if (emvData.encryptedTags != null){
				Map<String, byte[]> treeMap = new TreeMap<String, byte[]>(emvData.encryptedTags);
				appendMessageToResults("Encrypted Tags:\n" + mapDescription(treeMap));
			}
			if (emvData.maskedTags != null){
				Map<String, byte[]> treeMap = new TreeMap<String, byte[]>(emvData.maskedTags);
				appendMessageToResults("Masked Tags:\n" + mapDescription(treeMap));
			}
		}
	    long lEndTime = System.currentTimeMillis(); 
	    long difference = lEndTime - lStartTime;
	    
	    appendMessageToResults("Elapsed Time: " + String.valueOf(difference) + "ms");
	    inEMV = false;
		
	}
	
	
	private void receiptDialog(String title, String body){
		 AlertDialog.Builder alert = new AlertDialog.Builder(this);

	   		alert.setTitle(title);
	   	 
	   		alert.setMessage(body);
		   	
	   		alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
	   		public void onClick(DialogInterface dialog, int whichButton) {
	   		  
	   			textLCDsetText("UniPay Ready");
	   			
		   		  }
	   		});

	   		alert.setNegativeButton("Show Receipt", new DialogInterface.OnClickListener() {
	   		  public void onClick(DialogInterface dialog, int whichButton) {
	   			DlgReceipt myDlg = new DlgReceipt (UniPayEMVDemo.this, finalReceipt);
				myDlg.DisplayDlg();
	   		  }
	   		});

	   		alert.show();
	}
	
	
	private void setHeaderText(String message){
		headerTextView.setText(message);
	}
	
	static boolean waitForCardInsert = false;
	public void emvTransactionMessage(MESSAGE_Types message){
	    boolean skipHud = false;
	    switch (message) {
	        case MESSAGE_INSERT_OR_SWIPE_CARD:
	            appendMessageToResults("PLEASE INSERT OR SWIPE CARD");
	            textLCDsetText("PLEASE INSERT OR SWIPE CARD");
	            waitForCardInsert = true;
	            break;
	        case MESSAGE_REMOVE_CARD:
	        	appendMessageToResults("PLEASE REMOVE CARD");
	            //lcdDisplay.text = @"PLEASE REMOVE CARD";
	            waitForRemove = true;
	            inEMV = false;
	            break;
	        case MESSAGE_BAD_ICC:
	        	appendMessageToResults("CHIP READ ERROR-USE MSR\nPLEASE REMOVE CARD");
	        	textLCDsetText("CHIP READ ERROR-USE MSR\nPLEASE REMOVE CARD");
	            break;
	        case MESSAGE_TRANSACTION_CANCELLED:
	        	appendMessageToResults("TRANSACTION CANCELLED");
	        	textLCDsetText("TRANSACTION CANCELLED");
	        	inEMV = false;
	            break;
	        case MESSAGE_FALLBACK_FAILED:
	        	appendMessageToResults("FALLBACK FAILED");
	        	textLCDsetText("FALLBACK FAILED\nTRANSACTION CANCELLED");
	        	inEMV = false;
	            break;
	        case MESSAGE_USE_CHIP_READER:
	        	appendMessageToResults("MUST USE ICC READER");
	        	textLCDsetText("USE ICC READER\nPLEASE INSERT CARD");
	        	waitForCardInsert = true;
	            break;
	        case MESSAGE_PROCESSING:
	        	appendMessageToResults("PROCESSING");
	        	textLCDsetText("PROCESSING...");
	            showWaitDialog();
	            skipHud = true;
	            _hudON = true;
	            break;
	        case MESSAGE_READY:
	        	appendMessageToResults("UniPay Ready");
	        	textLCDsetText("UniPay Ready");
	        	inEMV = false;
	            break;
	        case MESSAGE_USE_MSR:
	        	appendMessageToResults("Please Swipe Card");
	        	textLCDsetText("PLEASE SWIPE CARD");
	            break;
	        case MESSAGE_SDK_ERROR:
	        	appendMessageToResults(sdkError(myUniPayEMV.getLastSDKError()));
	        	textLCDsetText(sdkError(myUniPayEMV.getLastSDKError()));
	        	inEMV = false;
	            break;
	        case MESSAGE_NOT_ACCEPTED:
	        	appendMessageToResults("Not Accepted");
	        	textLCDsetText("NOT ACCEPTED");
	        	inEMV = false;
	            break;

	        default:
	            break;
	    }
	   
	    if (_hudON && !skipHud) {
	    	hideWaitDialog();
	    	_hudON = false;
	    }
	}
	
	
	

	public void languagePreference(byte[] arg0) {
		// TODO Auto-generated method stub
		final String errorString = getHexStringFromBytes(arg0);
		 runOnUiThread(new Runnable() {
	       	    public void run() {
	       	    	ShowCommandResult("Language Bytes:",errorString,null);
	       	    }
	       	});
		
	}

	public void swipeMSRDataEMV(IDTMSRData card, Map<String, byte[]> tags) {
		textLCDsetText("UniPay Ready");
		// TODO Auto-generated method stub
		hideWaitDialog();
		StringBuilder sb = new StringBuilder();

		sb.append("Swipe Data Captured for EMV transaction\n");
		sb.append("Track 1: ");
		if (card.track1 != null) if (card.track1.length() > 0) sb.append(card.track1);
		sb.append("\nTrack 2: ");
		if (card.track2 != null) if (card.track2.length() > 0) sb.append(card.track2);
		sb.append("\nTrack 3: ");
		if (card.track3 != null) if (card.track3.length() > 0) sb.append(card.track3);
		sb.append("\n");
		if (card.encTrack1 != null) if (card.encTrack1.length > 0) sb.append("Enc. Track 1: " + getHexStringFromBytes(card.encTrack1) + "\n");
		if (card.encTrack2 != null) if (card.encTrack2.length > 0) sb.append("Enc. Track 2: " + getHexStringFromBytes(card.encTrack2) + "\n");
		if (card.encTrack3 != null) if (card.encTrack3.length > 0) sb.append("Enc. Track 3: " + getHexStringFromBytes(card.encTrack3) + "\n");
		if (card.serialNumber != null) if (card.serialNumber.length() > 0) sb.append("Serial Nunber: " + card.serialNumber + "\n");
		if (card.KSN != null) if (card.KSN.length > 0) sb.append("KSN: " + getHexStringFromBytes(card.KSN) + "\n");
	
		sb.append("\n");
		sb.append("Tags:\n");
		for (Map.Entry<String, byte[]> entry : tags.entrySet())
		{
			sb.append(entry.getKey() + ": " + getHexStringFromBytes(entry.getValue()));
			sb.append("\n");
		}
		final String errorString = sb.toString() + getReceipt(UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_GO_ONLINE, tags);
		 runOnUiThread(new Runnable() {
	       	    public void run() {
	       	    	ShowCommandResult("EMV Transaction Response:",errorString,null);
	       	    }
	       	});
		 
		 hideWaitDialog();
         // [self printReceipt:(int)emvData.resultCode tags:emvData.unencryptedTags];
      
      finalReceipt="";
      String myCard = card.track2;
      if (myCard == null) myCard = "";
	    	if (tags != null){
	    		finalReceipt = getReceiptMSR(tags,myCard);
	    	}
      
      
      
          String results = "Approved";
      textLCDsetText("APPROVED");
      waitForCardInsert = false;
      inEMV = false;
     
      /*
          
           final String _results = results;
           final String body = "MSR Transaction Approved";
     
          
          	 runOnUiThread(new Runnable() {
	           	    public void run() {
	           	    	receiptDialog(_results,body);
	           	    }
	           	});	
           */  
		
	}
	
	
	private String printRight(String str){
	    int len = str.length();
	    if (len > 31) {
	        return str;
	    }
	    for (int x = len; x < 32; x ++) {
	        str = " " + str;
	    }
	    return str;
	}
	private String printCenter(String str){
	    int len = str.length();
	    if (len > 30) {
	        return str;
	    }
	    for (int x = 0; x < (32-len)/2; x ++) {
	    	str = " " + str;
	    }
	    return str;
	}
	private String printJustified(String str, String str2){
	    int len = str.length() + str2.length();
	    if (len > 31) {
	        return str+str2;
	    }
	    for (int x = len; x < 32; x ++) {
	        str2 = " " + str2;
	    }
	    return str+str2;
	}


	private byte[] filterNull(byte[] bytes){
		if (bytes == null){
			byte[] retValue = {};
			return retValue;
		}
		return bytes;
	}
	
private String getReceiptMSR( Map<String,byte[]> resultTags, String track2){
		
	   
		
		
		StringBuilder str = new StringBuilder();
		str.append("\n\n\n======================\nReceipt\n======================\n\n");
	    
	    
	    Date curDate = new Date();

	   SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");   
	    String dateString=formatter.format(curDate);
	    
	    str.append(printCenter("ITSCO"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("10721 Walker Street"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("Cypress, CA 90630"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("714-761-8886"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("www.itsco.net"));
	    str.append(printCenter("\n"));
	    
	    str.append("--------------------------------");
	    str.append("\n");
	
	        str.append(printCenter("TRANSACTION SUCCESSFUL"));
		    str.append(printCenter("\n"));
	        str.append(printCenter("HOST APPROVED" ));
		    str.append(printCenter("\n"));
	    
	    
	    byte[] MID = filterNull(resultTags.get("9F16"));
	    String MIDStr = new String(MID);
	    
	    byte[] TID = filterNull(resultTags.get("9F1C"));
	    String TIDStr = new String(TID);

	    
	    str.append(printJustified("Merchant ID:",MIDStr));
	    str.append("\n");
	    
	    str.append(printJustified("Terminal ID:",TIDStr));
	    str.append("\n");
	    
	    String[] tsplit = track2.split("=");
	    
	    
	    String _pan = "";
	    if (tsplit[0].length()>5){
	    	_pan = tsplit[0].substring(1);
	    }

	

	    byte[] transTypes = filterNull(resultTags.get("9C"));
	    String _transType = getHexStringFromBytes(transTypes);
	    
	    byte[] theAmt = filterNull(resultTags.get("9F02"));
	    String _theAmt = getHexStringFromBytes(theAmt);
	    float money = Float.valueOf(_theAmt)/100;
	    
	   
	    NumberFormat fm = NumberFormat.getCurrencyInstance();
	    String moneyString = fm.format(money);
	    

	    str.append("--------------------------------");
	    str.append("\n");

	    
	    if (_pan.length() > 6) {
	        str.append(printJustified("Account","************" + _pan.substring(_pan.length()-4, _pan.length())));

	    }
	    else{
	        str.append(printJustified("Account",_pan));


	    }
	    str.append("\n");
	    str.append(printJustified("Transaction Type:",String.valueOf(_transType)));
	    str.append("\n");
	    str.append(printJustified("Date/Time:",dateString));
	    str.append("\n");
	    str.append(printJustified("Amount:",moneyString));
	    str.append("\n");


	
	    
	    String _AuthCode = "00";
	    
		    	
	    	str.append("AUTH:"+_AuthCode);
	    	str.append("\n\n\n\n");
	    	
	    	
	   
	    	
	        	str.append("\n\nCard Holder Signature:\n\n\n\n------------------------------\nI Acknowledge Satisfactory Rec-\n");
	        	str.append("eipt Of Relative Goods/Service\n\n\n\n\n");
	       
	        
	    
	    return str.toString();
	    
	}
	
	private String getReceipt(UniPayEMV.EMV_RESULT_CODE_Types resultCode, Map<String,byte[]> resultTags){
		
	    if (!(resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED || 
	    		resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_NO_REASON || 
	    		resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_DECLINED || 
	    	    resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_NOT_ACCEPT || 
	    	    resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_OFFLINE_APPROVED || 
	    	    resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_OFFLINE_DECLINED || 
	    		resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_IA_FAILED)){
	    	return "";
	    }
		
		
		StringBuilder str = new StringBuilder();
		str.append("\n\n\n======================\nReceipt\n======================\n\n");
	    
	    String success = "YES";
	    
	    Date curDate = new Date();

	   SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");   
	    String dateString=formatter.format(curDate);
	    
	    str.append(printCenter("ITSCO"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("10721 Walker Street"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("Cypress, CA 90630"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("714-761-8886"));
	    str.append(printCenter("\n"));
	    str.append(printCenter("www.itsco.net"));
	    str.append(printCenter("\n"));
	    
	    str.append("--------------------------------");
	    str.append("\n");
	    if (!(resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED || resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_NO_REASON || resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_IA_FAILED)) {
	        success = "NO";
	        str.append(printCenter("TRANSACTION FAILED"));
		    str.append(printCenter("\n"));
	        str.append(printCenter(resultCode.toString() ));
		    str.append(printCenter("\n"));	        
	    }
	    else{
	        str.append(printCenter("TRANSACTION SUCCESSFUL"));
		    str.append(printCenter("\n"));
	        str.append(printCenter(resultCode.toString() ));
		    str.append(printCenter("\n"));
	    }
	    
	    byte[] MID = filterNull(resultTags.get("9F16"));
	    String MIDStr = new String(MID);
	    
	    byte[] TID = filterNull(resultTags.get("9F1C"));
	    String TIDStr = new String(TID);

	    
	    str.append(printJustified("Merchant ID:",MIDStr));
	    str.append("\n");
	    
	    str.append(printJustified("Terminal ID:",TIDStr));
	    str.append("\n");
	    boolean useMasked = false;
	    byte[] pan2 = filterNull(_maskedTags.get("5A"));
	    String _pan2 = "";
	    useMasked = false;
	    if (pan2.length > 0){
	    	_pan2 = getHexStringFromBytes(pan2);
		    if (_pan2.length()>0) useMasked = true;
	    }
	    
	    
	    byte[] pan = filterNull(resultTags.get("5A"));
	    String _pan = getHexStringFromBytes(pan);

	

	    byte[] transTypes = filterNull(resultTags.get("9C"));
	    String _transType = getHexStringFromBytes(transTypes);
	    
	    byte[] theAmt = filterNull(resultTags.get("9F02"));
	    String _theAmt = getHexStringFromBytes(theAmt);
	    float money = Float.valueOf(_theAmt)/100;
	    
	   
	    NumberFormat fm = NumberFormat.getCurrencyInstance();
	    String moneyString = fm.format(money);
	    

	    str.append("--------------------------------");
	    str.append("\n");

	    if(useMasked){
	    	str.append(printJustified("Account",_pan2));
	    }
	    else if (_pan.length() > 6) {
	        str.append(printJustified("Account","************" + _pan.substring(_pan.length()-4, _pan.length())));

	    }
	    else{
	        str.append(printJustified("Account",_pan));


	    }
	    str.append("\n");
	    str.append(printJustified("Transaction Type:",String.valueOf(_transType)));
	    str.append("\n");
	    str.append(printJustified("Date/Time:",dateString));
	    str.append("\n");
	    str.append(printJustified("Amount:",moneyString));
	    str.append("\n");

	    byte[] iad = filterNull(resultTags.get("91"));
	    String _iad = "11223344556677883030";
	    if (iad != null){
	    	if (iad.length > 0){
	    		_iad = getHexStringFromBytes(iad);
	    	}
	    }
	    str.append(printJustified("IAD:",_iad));
	    str.append("\n");
	    
	    byte[] aid = filterNull(resultTags.get("84"));
	    String _aid = getHexStringFromBytes(aid);
	    
	    str.append(printJustified("AID:",_aid));
	    str.append("\n");



	    
	    byte[] AuthCode = filterNull(resultTags.get("8A"));
	    String _AuthCode = new String(AuthCode);
	    
	    byte[] aac = filterNull(resultTags.get("9F26"));
	    String _aac = getHexStringFromBytes(aac);
	    
	    if (!(resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED || resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_NO_REASON || resultCode == UniPayEMV.EMV_RESULT_CODE_Types.EMV_RESULT_CODE_APPROVED_WITH_ADVISE_IA_FAILED)){
	    	str.append(printJustified("AUTH:"+_AuthCode,"AAC:"+_aac));
	    	str.append("\n\n\n\n\n\n");
	    }
	    else{
	    	
	    	str.append(printJustified("AUTH:"+_AuthCode,"TC:"+_aac));
	    	str.append("\n\n\n\n");
	    	
	    	
	    	if (signatureCVM){
	    	
	        	str.append("\n\nCard Holder Signature:\n\n\n\n------------------------------\nI Acknowledge Satisfactory Rec-\n");
	        	str.append("eipt Of Relative Goods/Service\n\n\n\n\n");
	        }
	        
	    }
	    return str.toString();
	    
	}
	DEVICE_INTERFACE_Types dt = DEVICE_INTERFACE_Types.DEVICE_UNKNOWN;
	public void plugStatusChange(DEVICE_INTERFACE_Types deviceType, boolean deviceInserted) {
		// TODO Auto-generated method stub
		if(true==deviceInserted)
	 		handler.post(device_connect);
		else
			handler.post(device_disconnect);
		dt = deviceType;

	}
	public void LoadXMLConfigFailureInfo(int arg0, String arg1) {
		// TODO Auto-generated method stub
		
	}
	public void autoConfigCompleted(StructConfigParameters arg0) {
		// TODO Auto-generated method stub
		
	}
	public void autoConfigProgress(int arg0) {
		// TODO Auto-generated method stub
		
	}
	public void deviceConnectedUsb() {
		// TODO Auto-generated method stub
		
	}
	public void deviceDisconnectedUsb() {
		// TODO Auto-generated method stub
		
	}
	public void msgAudioVolumeAjustFailed() {
		// TODO Auto-generated method stub
		
	}
	public void timeout(int arg0) {
		// TODO Auto-generated method stub
		
	}


}